/*-----------------------------------------*/
/*   GUI.H header file                     */
/*-----------------------------------------*/
/*-----------------------------------------*/
/*  Definitionen fr PanPlot               */
/*  Dr. Rainer Sieger, AWI-Bremerhaven     */
/*-----------------------------------------*/

#define  HorizontalMode       0
#define  VerticalMode         1
#define  TernaryMode          2
#define  PhaseMode            3

#define  NORMAL               0
#define  BOLD                 1

#define NoInit                0
#define Init                  1
#define Export                2
#define ExportToFile          3
#define Print                 4

#define CommandTaste          0
#define Maus                  1

#define UNTITLED							"(untitled)"

#define useGroups             1
#define useParameters         2

/*-----------------------------------------*/

#define ABOUTBITMAP                       10

/*-----------------------------------------*/

#define IDD_FNAME                         10

//-------------------------------------------
// Bitmaps

#define IDB_ABOUT                         10

//-------------------------------------------
// Mens

#define IDM_OPEN                         			40001
#define IDM_EXIT                         			40002
#define IDM_CLOSE                        			40003
#define IDM_SETMEMORY                    			40004

#define IDM_NEW                           		1000
#define IDM_RELOAD														1010
#define IDM_SAVE                          		1020
#define IDM_SAVEAS                        		1030
#define IDM_SAVEDATADESCRIPTION            		1035
#define IDM_EXPORT                        		1040
#define IDM_BATCH                         		1050
#define IDM_PAGESETUP                     		1060
#define IDM_PRINT                         		1070
#define IDM_PRINTNODIALOG											1071
#define IDM_LOAD_TEMPLATE                 		1080
#define IDM_SAVE_TEMPLATE                 		1090
#define IDM_SAVEPREFS                     		1100

#define IDM_UNDO                          		2000
#define IDM_CUT                           		2010
#define IDM_COPY                          		2020
#define IDM_PASTE                         		2030
#define IDM_CLEAR                         		2040
#define IDM_SELALL                        		2050
#define IDM_PLOTNEW                       		2060

#define IDM_HorizontalMode                		3000
#define IDM_VerticalMode                  		3010
#define IDM_TernaryMode                   		3020
#define IDM_PhaseMode                     		3030

#define IDM_GRAPHIC                       		3040
#define IDM_XAXIS                         		3050
#define IDM_YAXIS_SELECTBYPARAMETERS      		3060
#define IDM_YAXIS_SELECTBYGROUPS          		3070
#define IDM_YAXIS_SELALL                  		3080
#define IDM_YAXIS_SELNONE                 		3090

#define IDM_YAXIS_SETALL                  		3100
#define IDM_YAXIS_MAXAXISLENGTH           		3101
#define IDM_YAXIS_RANGE                   		3102
#define IDM_YAXIS_TICKS                   		3103
#define IDM_YAXIS_ADDNEXT                 		3104
#define IDM_YAXIS_MARKER                  		3105
#define IDM_YAXIS_OPTIONS                 		3106
#define IDM_YAXIS_QUALITY_FLAGS         			3107
#define IDM_YAXIS_COLOR                   		3108
#define IDM_YAXIS_COLOR_MAPPING								3109
#define IDM_YAXIS_LINEWIDTH               		3110
#define IDM_YAXIS_COLUMNWIDTH             		3111
#define IDM_YAXIS_PARAMETER_TEXT_ORIENTATION 	3112
#define IDM_GEPSILON                      		3113

#define IDM_SPLITDATAFILE                 		4000
#define IDM_MACTOWIN			                 		4010
#define IDM_WINTOMAC			                 		4020

#define IDM_INFO                          		5010
#define IDM_VERSION                       		5020
#define IDM_HELP                          		5030
#define IDM_ABOUT                         		5040

#define IDM_TILE															6000
#define IDM_CASCADE														6010
#define IDM_ARRANGE														6020
#define IDM_CLOSEALL													6030

#define IDM_OPENDATAPLOTWINDOW								6040
#define IDM_OPENDATADESCRIPTIONWINDOW					6050
#define IDM_EDITDATADESCRIPTION								6060
#define IDM_RELOADDATADESCRIPTION							6070

#define IDC_EDITDATADESCRIPTION         			7000
#define IDC_TITLE                       			7001

#define IDM_FIRSTCHILD												 100

//-------------------------------------------
// Dialoge

// Graphic
#define IDC_WINDOWWIDTH                 1300
#define IDC_WINDOWHEIGHT                1301
#define IDC_DISTANCE                    1302
#define IDC_ALLINONE                    1303
#define IDC_UNITA                       1144
#define IDC_UNITB                       1145
#define IDC_HEADERHEIGHT                1304
#define IDC_COPYRIGHTTEXT               1305
#define IDC_USECOLOR                    1306
#define IDC_USEDEFAULTCOLOR             1307
#define IDC_USETEMPLATE                 1308
#define IDC_ABSOLUTESCALE               1309
#define IDC_TICKLINECOLOR               1310
#define IDC_TICKLINEWIDTH               1311
#define IDC_KOORLINEWIDTH               1312
#define IDC_CHOOSEFONT                  1313
#define IDC_GTICKINCREMENT              1314
#define IDC_CRDateTime                  1315
#define IDC_CRFilename                  1316
#define IDC_LANDSCAPE                   1317
#define IDC_PORTRAIT                    1318

// X-Axis
#define IDC_LABEL                       1400
#define IDC_XMIN                        1401
#define IDC_XMAX                        1402
#define IDC_XAUTO                       1403
#define IDC_XTICKINCREMENT              1404
#define IDC_XMINORMARKS                 1405
#define IDC_XBOTHSIDE                   1406
#define IDC_XINSIDE                     1407
#define IDC_XTICKLINES                  1408
#define IDC_MXTICKLINES                 1409
#define IDC_XREFLINE                    1410
#define IDC_CLIPAXIS                    1411

// Y-Axis
#define IDC_YLABEL                      1000
#define IDC_ADDNEXT                     1001
#define IDC_YAUTO                       1002
#define IDC_YMIN                        1003
#define IDC_YMAX                        1004
#define IDC_REFLINE                     1005
#define IDC_LOG                         1006
#define IDC_MARKER                      1007
#define IDC_MSYMBOL                     1008
#define IDC_MSIZE                       1009
#define IDC_LINES                       1010
#define IDC_COLORIZE                    1011
#define IDC_HISTOCOL                    1012
#define IDC_HISTOLIN                    1013
#define IDC_HISTOOUT                    1014
#define IDC_YTICKINCREMENT              1015
#define IDC_YMINORMARKS                 1016
#define IDC_YBOTHSIDE                   1017
#define IDC_YINSIDE                     1018
#define IDC_YTICKLINES                  1019
#define IDC_MYTICKLINES                 1020
#define IDC_PRE                         1021
#define IDC_POST                        1022
#define IDC_SETCOLOR                    1023
#define IDC_FIXEDPARAMETER              1024
#define IDC_PARAMETERWIDTH              1025
#define IDC_LINEWIDTH                   1026
#define IDC_TEXT                        1027
#define IDC_OCCURRENCE                  1028
#define IDC_COURSE                      1029
#define IDC_COMMENT                     1030
#define IDC_LITHO		                		1031
#define IDC_BOUNDARY                    1032
#define IDC_GROUPNAME                   1033
#define IDC_GROUPNAMEON                 1034
#define IDC_PARAMETERNAMEON             1035
#define IDC_PAINT                       1036
#define IDC_UPDOWN                      1037
#define IDC_SETFIRSTCOLOR               1038
#define IDC_SETLASTCOLOR                1039
#define IDC_SHOWVALID                   1040
#define IDC_SHOWNOTVALID  	            1041
#define IDC_SHOWUNKNOWN                 1042
#define IDC_SHOWQUESTIONABLE            1043
#define IDC_SHOWMISSVAL                 1044
#define IDC_YREVERSE                    1045
#define IDC_XREVERSE                    1046

// Dialog "Ternary"
#define IDC_GLABEL                      1100
#define IDC_EPSILON                     1101

// Dialog "Select"
#define IDC_CHECK1                      1201
#define IDC_CHECK2                      1202
#define IDC_CHECK3                      1203
#define IDC_CHECK4                      1204
#define IDC_CHECK5                      1205
#define IDC_CHECK6                      1206
#define IDC_CHECK7                      1207
#define IDC_CHECK8                      1208
#define IDC_CHECK9                      1209
#define IDC_CHECK10                     1210
#define IDC_CHECK11                     1211
#define IDC_CHECK12                     1212
#define IDC_CHECK13                     1213
#define IDC_CHECK14                     1214
#define IDC_CHECK15                     1215
#define IDC_CHECK16                     1216
#define IDC_CHECK17                     1217
#define IDC_CHECK18                     1218
#define IDC_CHECK19                     1219
#define IDC_CHECK20                     1220
#define IDC_CHECK21                     1221
#define IDC_CHECK22                     1222
#define IDC_CHECK23                     1223
#define IDC_CHECK24                     1224
#define IDC_CHECK25                     1225
#define IDC_CHECK26                     1226
#define IDC_CHECK27                     1227
#define IDC_CHECK28                     1228
#define IDC_CHECK29                     1229
#define IDC_CHECK30                     1230
#define IDC_CHECK31                     1231
#define IDC_CHECK32                     1232
#define IDC_CHECK33                     1233
#define IDC_CHECK34                     1234
#define IDC_CHECK35                     1235
#define IDC_CHECK36                     1236
#define IDC_CHECK37                     1237
#define IDC_CHECK38                     1238
#define IDC_CHECK39                     1239
#define IDC_CHECK40                     1240
#define IDC_CHECK41                     1241
#define IDC_CHECK42                     1242
#define IDC_CHECK43                     1243
#define IDC_CHECK44                     1244
#define IDC_CHECK45                     1245
#define IDC_CHECK46                     1246
#define IDC_CHECK47                     1247
#define IDC_CHECK48                     1248
#define IDC_CHECK49                     1249
#define IDC_CHECK50                     1250
#define IDC_CHECK51                     1251
#define IDC_CHECK52                     1252
#define IDC_CHECK53                     1253
#define IDC_CHECK54                     1254
#define IDC_CHECK55                     1255
#define IDC_CHECK56                     1256
#define IDC_CHECK57                     1257
#define IDC_CHECK58                     1258
#define IDC_CHECK59                     1259
#define IDC_CHECK60                     1260

#define IDC_SELECTALL                   1270
#define IDC_SELECTNONE                  1271

// Dialog "Split file"
#define IDC_INCREMENT                   1500

// Dialog "Do with next"
#define IDC_ADD                         1600
#define IDC_PLOT                        1601

// Dialog "Parameter text orientation"
#define IDC_0_DEG                       1152
#define IDC_45_DEG                      1153
#define IDC_90_DEG                      1154

// Dialog "Batch
#define IDC_BATCHSAVE                   1700
#define IDC_BATCHPLOT                   1701

// Dialog "Change mode"
#define IDC_ALLPARAMETERS               1800
#define IDC_SELECTEDPARAMETERS          1801

// Dialog "Set memory"
#define IDC_MEMORYNUMERIC								1900
#define IDC_MEMORYTEXT									1901

// ********************************************
// Mauszeiger

#define IDC_BALL1                       129
#define IDC_BALL2                       130
#define IDC_BALL3                       131
#define IDC_BALL4                       132

// ********************************************
// Rnder

extern int RLT;  // Rand links zum Text
extern int RRT;  // Rand rechts zum Text
extern int ROT;  // Rand oben zum Text
extern int RUT;  // Rand unten zum Text

#define MSL    8  // Max scale length
#define ATE    3  // Abstand zwischen Title und Unit

// ********************************************
// Ressourcen IDs

#define rMaxNumOfParametersOverflow		128
#define rOutOfMemory									129
#define rOutOfPICTMemory							130
#define rMaxDataOverflow              131
#define rWrongData                    132
#define rSaveGraphic                  133
#define rVersion                      134
#define rInfo                         135
#define rFileError                    136
