/*******************************************************************
*                                                                  *
*    Do_Batch.c -- Erzeugen vieler *.emf-Dateien                   *
*                                                                  *
*    Dr. Rainer Sieger, AWI-Bremehaven, 04.09.97                   *
*    Windows only                                                  *
*                                                                  *
*******************************************************************/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "Fileselect.h"
#include "Do_Batch.h"

#include "Window.h"
#include "MinMax.h"
#include "SetMinMax.h"
#include "Plotter.h"
#include "ExportPicture.h"
#include "ReadData.h"
#include "Ezfont.h"
#include "Dialog.h"
#include "PrintPicture.h"

int	 RadioButton = 0;

int Do_Batch(HWND hwnd, HINSTANCE hInst)
{
	HDC						hdc;
	
	int						NumOfFiles = -1;
	int						i          = 0;
	int						err        = 0;
  char					*p;

	PAINTSTRUCT		ps;

  StrFullName   AFilename   = "";
  StrName       AName       = "";
  StrPath       APath       = "";

// ********************
//  Sichern alter Inhalte

  strcpy((char *) AName, (char *) Name);
  strcpy((char *) APath, (char *) Path);
  strcpy((char *) AFilename, (char *) Path);
  strcat((char *) AFilename, (char *) Name);

  DialogBox (hInst, "BATCHDIALOG", hwnd, (DLGPROC) Do_BatchDialog);
  
	if (RadioButton < 1)
		return(-1);

	if ((NumOfFiles = MultiFileOpenDlg (hwnd, hInst)) > 0)
	{
	  Batch = 1;
		strcpy((char *) Path, (char *) BPath);

		for (i=1;i<=NumOfFiles;i++)
		{
			strcpy((char *) Name, (char *) Filelist[i]);
			strcpy((char *) FullName, (char *) BPath);
			strcat((char *) FullName, (char *) Name);
			strcpy((char *) PFullName, (char *) FullName);

			if (((p = strstr((char *) PFullName, ".PP")) != NULL) || ((p = strstr((char *) PFullName, ".pp")) != NULL))
				*p = '\0';
			strcat ((char *) PFullName,".emf");

			if ((gNumOfParameters = ReadData (hwnd)) > 0) 
			{
				DoCaptionDataPlotWindow (hwnd, (char *) FullName);
				MinMax();

				if (useTemplate == 0)
				{
					gSelectedNumOfParameters = gNumOfParameters;
					SetMinMax(0);
				}  
				else  
					SetMinMax(-1);

				InvalidateRgn (hwnd, NULL, TRUE); 
				
				hdc          = BeginPaint (hwnd, &ps);
 				
				GetLogicalResolution (hdc, TRUE, &cxDpi, &cyDpi);
        
				ScreenDpi    = (int) cxDpi;
        dpcm         = (int) (ScreenDpi/2.54f);
				
				Plotter (hdc,Init);
	      EndPaint (hwnd, &ps);

				if (RadioButton < 2)
					err = ExportPicture (hwnd, TOFILE);
				else
					PrintPicture (hwnd, 1);
			}  
		}

// **********************
// alten Zustand wieder herstellen

	  strcpy((char *) Name, (char *) AName);
		strcpy((char *) Path, (char *) APath);
		strcpy((char *) FullName, (char *) Path);
		strcat((char *) FullName, (char *) Name);

		if ((gNumOfParameters = ReadData (hwnd)) > 0) 
		{
			DoCaptionDataPlotWindow (hwnd, (char *) FullName);
			MinMax();
			if (useTemplate == 0)
			{
				gSelectedNumOfParameters = gNumOfParameters;
				SetMinMax(0);
			}  
			else  
				SetMinMax(-1);
		}

		InvalidateRgn(hwnd, NULL, TRUE); 

		Batch = 0;

		return(0);
	}
	else
		return(-1);
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_BatchDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	static int  IDC_Radio[maxRadio+1] = {0,IDC_BATCHSAVE,IDC_BATCHPLOT,0};

// *************************************************************************

	switch (iMsg)
			{
			case WM_INITDIALOG :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
					SetFocus(hDlg);
					return FALSE;
					break;

			case WM_COMMAND :
						switch (LOWORD (wParam))
								{
								case IDOK :
											EndDialog (hDlg, TRUE);
											return TRUE;
											break;

								case IDC_BATCHSAVE :
											RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
											return TRUE;
											break;

								case IDC_BATCHPLOT :
											RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 2);
											return TRUE;
											break;

								case IDCANCEL :
											RadioButton = 0;
											EndDialog (hDlg, FALSE);
											return TRUE;
											break;

								default:
											break;
								}
						break;

			case WM_PAINT :
						break;

			default:
						break;
			}

		return FALSE;
}

