/*******************************************************************
*                                                                  *
*    Do_FileMenu.c -- Behandlung des Mens "File"                  *
*                                                                  *
*    Dr. Rainer Sieger, Universitt Bremen, 22.04.2001             *
*    Windows only                                                  *
*                                                                  *
*******************************************************************/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "WndProc.h"
#include "Win_GUI.h"
#include "Fileselect.h"
#include "Do_FileMenu.h"
#include "Dialog.h"

#include "ReadData.h"
#include "Templates.h"
#include "SaveFile.h"
#include "Preferences.h"
#include "SetMemory.h"
#include "SetMinMax.h"
#include "MinMax.h"
#include "ExportPicture.h"
#include "DisableParameter.h"
#include "replaceStr.h"

//------------------------------------------------------------------

int Do_SetMemory (HWND hwnd, HINSTANCE hInst)
{
		DialogBox (hInst, "SETMEMORYDIALOG", hwnd, (DLGPROC) (DLGPROC) Do_SetMemoryDialog);

		return(0);
}

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

int Do_Open (HWND hwnd, HINSTANCE hInst, int iLoad)
{   
	int         err         = 0;

	StrFullName FullNameIn  = "";
	StrName     NameIn      = "";
	StrPath     PathIn      = "";   
	StrFullName FullNameOut = "";
	StrName     NameOut     = "";
	StrPath     PathOut     = "";

//------------------------------------------------------------------

	switch (iLoad)
	{
		case LoadData:
			AutoLoadData 					= 0;
			DataDescriptionSaved	= 0;
			gNumOfParameters			= ReadData(hwnd);

			if (gNumOfParameters > 0) 
			{
   			gSelectedNumOfParameters = gNumOfParameters;
   			MinMax();
   			SetMinMax(0);
				disableParameter(gNumOfParameters);
				return(0);
			} 
			else
			{
				return(-1);
			}
			break;

		case LoadDataRequest:
			FileInitialize (hwnd, FileExtension);
			if (FileOpenDlg (hwnd, hInst, (char *) FullName, (char *) Path, (char *) Name, "Select data"))
			{
				gNumOfParameters = ReadData(hwnd);

				if (gNumOfParameters > 0) 
				{
     			MinMax();
      		if (useTemplate)
						SetMinMax (-1);
					else
      		{
      			gSelectedNumOfParameters = gNumOfParameters;
      			SetMinMax (0);
      		} 
					disableParameter(gNumOfParameters);
					return(0);
				}
				else
				{
					return(-1);
				}
			}
			else
			{
				if (gNumOfParameters < 0)
					gNumOfParameters = -3;

				return(-2);
			}
			break;
	      
		case LoadTemplate:
			FileInitialize (hwnd, PTF);
			if (FileOpenDlg (hwnd, hInst, (char *) TFullName, (char *) TPath, (char *) TName, "Select template"))
			{
				if ((err = LoadTemplates()) == 0) 
				{
					SetMinMax(-1);
				}	
				else
				{
					if (err < -1)
    				err = Do_StopAlert(hwnd,rWrongData);
    			else
    				err = Do_StopAlert(hwnd,rVersion); 
	
					gNumOfParameters = ReadData(hwnd);
     			gSelectedNumOfParameters  = gNumOfParameters;
     			MinMax();
      		SetMinMax(0);
					disableParameter(gNumOfParameters);
				} 
			}
			break;

		default:
			break;
	}

	return(0);
}

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

int Do_Saveas (HWND hwnd, HINSTANCE	hInst, int Saveas)
{   
	StrFullName     FullName_old	= "";

	int             err     			= 0;

//------------------------------------------------------------------

	switch (Saveas)
	{
		case SaveData:
  		strcpy((char *) FullName_old, (char *) Path);
  		strcat((char *) FullName_old, (char *) Name);

			FileInitialize(hwnd, PP);

			if (FileSaveDlg(hwnd, hInst, (char *) FullName, (char *) Path, (char *) Name, "Save data as..."))
				err = SaveFile((char *) FullName_old, (char *) FullName);

			break;
	    
		case SaveDataDescription:
			DataDescriptionSaved = 0;

			FileInitialize(hwnd, TXT);
			
			strcpy((char *) DDFullName, (char *) Path);
			strcat((char *) DDFullName, "DD_");
			strcat((char *) DDFullName, (char *) Name);
			replaceStr((char *) DDFullName, ".tab", ".txt");

			if (FileSaveDlg(hwnd, hInst, (char *) DDFullName, (char *) DDPath, (char *) DDName, "Save data description as..."))
			{
				err = SaveDataDescriptionFile((char *) DDFullName);

				if (err == 0)
					DataDescriptionSaved = 1;
			}
			break;
	    
		case ExportPICT:
			FileInitialize(hwnd, PPP);

			strcpy((char *) PFullName, (char *) Path);
			strcat((char *) PFullName, (char *) Name);
			replaceStr((char *) PFullName, ".tab", ".emf");

			if (FileSaveDlg(hwnd, hInst, (char *) PFullName, (char *) PPath, (char *) PName, "Select export file"))
				err = ExportPicture(hwnd,TOFILE);

			break;

		case SaveTemplate:
			FileInitialize(hwnd, PTF);

			if (FileSaveDlg(hwnd, hInst, (char *) TFullName, (char *) TPath, (char *) TName, "Select template"))
				err = SaveTemplates();

			break;

		default:
			break;
	}   

	return(err);
}

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

int Do_New (void)
{   
//  gib's hier nicht.
	return 0;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

int Do_Save (void)
{   
//  gib's hier nicht.
	return(0);
}



