/*--------------------------------------------*/
/*  Do_SelectDialog - Selectdialog            */
/*  Dr. Rainer Sieger, Universitt Bremen     */
/*  07.06.2000                                */
/*--------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Color.h"
#include "Dialog.h"
#include "SplitHeader.h"
#include "Do_SelectDialog.h"

BOOL CALLBACK Do_SelectDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  int					i        = 0;
  int					j        = 0;

  int					F				 = FALSE;
  int					T				 = TRUE;

  Str80				DummyStr = "";

	static int  ParameterIDOffset;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
			ParameterIDOffset = InitDialog(hDlg, 0);
      SetFocus(hDlg);
      return FALSE;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
					ReadDialog(hDlg, ParameterIDOffset);
          EndDialog (hDlg, TRUE);
					gSelectedNumOfParameters = 0;
					for (j=1;j<=gNumOfParameters;j++)
					{
						if (ST[j].PlotData > 0)
							gSelectedNumOfParameters++;
					}
          return TRUE;
					break;

        case IDC_SELECTALL :
          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
					{
						GetDlgItemText(hDlg,i,(char *) DummyStr,80);
						if (strlen((char *) DummyStr) > 0)
							SetCheckButton(hDlg, i, Set, &T);
					}

					for (j=1;j<=gNumOfParameters;j++)
						ST[j].PlotData = 1;
          
					return TRUE;
					break;

        case IDC_SELECTNONE :
          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
		        SetCheckButton(hDlg, i, Set, &F);
					
					for (j=1;j<=gNumOfParameters;j++)
						ST[j].PlotData = 0;
          
					return TRUE;
					break;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
					break;

        case IDC_PRE :
					ReadDialog(hDlg, ParameterIDOffset);
					ParameterIDOffset = InitDialog(hDlg,ParameterIDOffset-1);
				  SetFocus(hDlg);
					return FALSE;
					break;

        case IDC_POST :
					ReadDialog(hDlg, ParameterIDOffset);
					ParameterIDOffset = InitDialog(hDlg,ParameterIDOffset+1);
				  SetFocus(hDlg);
					return FALSE;
					break;

				case IDC_CHECK1 :
				case IDC_CHECK2 :
				case IDC_CHECK3 :
				case IDC_CHECK4 :
				case IDC_CHECK5 :
				case IDC_CHECK6 :
				case IDC_CHECK7 :
				case IDC_CHECK8 :
				case IDC_CHECK9 :
				case IDC_CHECK10 :
				case IDC_CHECK11 :
				case IDC_CHECK12 :
				case IDC_CHECK13 :
				case IDC_CHECK14 :
				case IDC_CHECK15 :
				case IDC_CHECK16 :
				case IDC_CHECK17 :
				case IDC_CHECK18 :
				case IDC_CHECK19 :
				case IDC_CHECK20 :
				case IDC_CHECK21 :
				case IDC_CHECK22 :
				case IDC_CHECK23 :
				case IDC_CHECK24 :
				case IDC_CHECK25 :
				case IDC_CHECK26 :
				case IDC_CHECK27 :
				case IDC_CHECK28 :
				case IDC_CHECK29 :
				case IDC_CHECK30 :
				case IDC_CHECK31 :
				case IDC_CHECK32 :
				case IDC_CHECK33 :
				case IDC_CHECK34 :
				case IDC_CHECK35 :
				case IDC_CHECK36 :
				case IDC_CHECK37 :
				case IDC_CHECK38 :
				case IDC_CHECK39 :
				case IDC_CHECK40 :
				case IDC_CHECK41 :
				case IDC_CHECK42 :
				case IDC_CHECK43 :
				case IDC_CHECK44 :
				case IDC_CHECK45 :
				case IDC_CHECK46 :
				case IDC_CHECK47 :
				case IDC_CHECK48 :
				case IDC_CHECK49 :
				case IDC_CHECK50 :
				case IDC_CHECK51 :
				case IDC_CHECK52 :
				case IDC_CHECK53 :
				case IDC_CHECK54 :
				case IDC_CHECK55 :
				case IDC_CHECK56 :
				case IDC_CHECK57 :
				case IDC_CHECK58 :
				case IDC_CHECK59 :
				case IDC_CHECK60 :
					i = LOWORD(wParam);
					switch (SelectMode)
					{
						case useParameters:
							j = i - IDC_CHECK1 + 1 + ParameterIDOffset*60;
							
							if (j <= gNumOfParameters)
							{
								if (ST[j].PlotData > 0)
								{
									SetCheckButton(hDlg, i, Set, &F);
									ST[j].PlotData = 0;
								}
								else
								{
									SetCheckButton(hDlg, i, Set, &T);
									ST[j].PlotData = 1;
								}
							}
							else
							{
								SetCheckButton(hDlg, i, Set, &F);
							}
							break;

						case useGroups:
							j = i - IDC_CHECK1 + 1;
							
							if (j <= gNumOfGroups)
							{
								if (ST[j].GPlotData > 0)
								{
									SetCheckButton(hDlg, i, Set, &F);
									ST[j].GPlotData = 0;
								}
								else
								{
									SetCheckButton(hDlg, i, Set, &T);
									ST[j].GPlotData = 1;
								}
							}
							else
							{
								SetCheckButton(hDlg, i, Set, &F);
							}
							break;
					}
          return TRUE;
					break;

				default:
					break;
      }
      break;

    case WM_PAINT :
      break;

		default:
			break;
  }

  return FALSE;
}

// *************************************************************************
// *************************************************************************
// *************************************************************************

int InitDialog(HWND hDlg, int ParameterIDOffset)
{
	int   i							= 0;
	int   j							= 0;
	int		k							= 1;
	int   F							= FALSE;
	int		T							= TRUE;
	int   max_IDC_CHECK = 0;

	Str80 Group					= "";
	Str80 Title					= "";
	Str80 Unit					= "";
	Str80 DummyStr			= "";

// *************************************************************************

	if (ParameterIDOffset < 0)
		return 0;

	i = (int) ((float) gNumOfParameters/(float) 60);
	
	if (ParameterIDOffset > i)
		return i;

  switch (SelectMode)
  {
   	case useParameters:
	    max_IDC_CHECK = gNumOfParameters + IDC_CHECK1 - 1 - ParameterIDOffset*60;
			break;	      

    case useGroups:
		  max_IDC_CHECK = gNumOfGroups + IDC_CHECK1 - 1;
	    break;	      

		default:
			break;
	}
	
  if (max_IDC_CHECK > IDC_CHECK60)
    max_IDC_CHECK = IDC_CHECK60;

	switch (SelectMode)
  {
    case useParameters:
			for (i=IDC_CHECK1;i<=max_IDC_CHECK;i++)
			{
				j = i-IDC_CHECK1+1 + ParameterIDOffset*60;
				memset((char *) DummyStr, (int) '\0', 80);
				
				if (strlen((char *) C[j].Header) > 0)
				{
					SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 
					strcpy((char *) DummyStr,(char *) Title);		
					strcat((char *) DummyStr,(char *) " ");		
					strcat((char *) DummyStr,(char *) Unit);		
				}

				SetDlgItemText(hDlg,i,(char *) DummyStr);
				
				if (ST[j].PlotData > 0)
					SetCheckButton(hDlg, i, Set, &T);
				else
					SetCheckButton(hDlg, i, Set, &F);
			}

			memset((char *) DummyStr, (int) '\0', 80);
			
			for (i=max_IDC_CHECK+1;i<=IDC_CHECK60;i++)
			{
				SetDlgItemText(hDlg,i,(char *) DummyStr);
				SetCheckButton(hDlg, i, Set, &F);
			}
			break;

		case useGroups:
			for (i=IDC_CHECK1;i<=max_IDC_CHECK;i++)
			{
				j = i-IDC_CHECK1+1;
				SetDlgItemText(hDlg,i,(char *) C[k].GroupName);
			
				if (ST[j].GPlotData > 0)
					SetCheckButton(hDlg, i, Set, &T);

				k += C[j].NumOfParametersInGroup;	
			}

			memset((char *) DummyStr, (int) '\0', 80);

			for (i=max_IDC_CHECK+1;i<=IDC_CHECK60;i++)
			{
  			SetDlgItemText(hDlg,i,(char *) DummyStr);
				SetCheckButton(hDlg, i, Set, &F);
			}
      break;

		default:
			break;
  }

	return ParameterIDOffset;
}

// *************************************************************************
// *************************************************************************
// *************************************************************************

void ReadDialog(HWND hDlg, int ParameterIDOffset)
{
  int   i     = 0;
  int   j     = 0;
	int   k     = 0;
	int		g			= 0;

  int   dummy = 0;

// *************************************************************************

	switch (Mode)
	{
		case VerticalMode:
		case HorizontalMode:
			switch (SelectMode)
      {
			  case useParameters:
          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
          {
            j = i-IDC_CHECK1+1 + ParameterIDOffset*60;
  
						if (IsDlgButtonChecked(hDlg,i) == 1)
            {
              dummy  = ST[j].PlotMarker + ST[j].PlotLine + ST[j].Colorize;
              dummy += ST[j].PlotCHistogramm + ST[j].PlotLHistogramm;
						  dummy += ST[j].PlotText + ST[j].PlotOccurrence + ST[j].PlotComment;

							if (dummy < 1)
							{
								if (C[j].counts > 0)
		          	{
									ST[j].PlotMarker  = 1;
		            	ST[j].PlotLine    = 1;
								}
								else
								{
									ST[j].PlotComment = 1;		            
								}
              }

							ST[j].PlotData = 1;
            }
						else
						{
							ST[j].PlotData = 0;
						}
          }
          break;

				case useGroups:
          gSelectedNumOfParameters = 0;
				  g												 = 0;

          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
          {
            if (IsDlgButtonChecked(hDlg,i) == 1)
            {
							j = i-IDC_CHECK1+1;
          
							for (k=1;k<=C[j].NumOfParametersInGroup;k++)
            	{
								if (++g < MAXNUMOFPARAMETERS)
								{
									dummy  = ST[g].PlotMarker + ST[g].PlotLine + ST[g].Colorize;
									dummy += ST[g].PlotCHistogramm + ST[g].PlotLHistogramm;
									dummy += ST[g].PlotText + ST[g].PlotOccurrence + ST[g].PlotComment;

									if (dummy < 1)
									{
										if (C[g].counts > 0)
										{
		            			ST[g].PlotMarker  = 1;
		            			ST[g].PlotLine    = 1;
										}
										else
										{
		            			ST[g].PlotComment = 1;		            
										}
									}

									ST[g].PlotData = 1;
									gSelectedNumOfParameters++;
								}
							}

              ST[j].GPlotData = 1;
						}
            else
            {
							j = i-IDC_CHECK1+1;
          		
							for (k=1;k<=C[j].NumOfParametersInGroup;k++)
            	{
								if (++g < MAXNUMOFPARAMETERS)
									ST[g].PlotData = 0;
				      }

              ST[j].GPlotData = 0;
				    }  
          }
          break;

				default:
					break;
			}
			break;

    case TernaryMode :
      switch (SelectMode)
      {
				case useParameters:
          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
          {
	          j = i-IDC_CHECK1+1 + ParameterIDOffset*60;
          
						if (IsDlgButtonChecked(hDlg,i) == 1)
              ST[j].PlotData = 1;
          }
          break;

				case useGroups:
          gSelectedNumOfParameters = 0;
          for (i=IDC_CHECK1;i<=IDC_CHECK60;i++)
          {
            j = i-IDC_CHECK1+1;

						if (IsDlgButtonChecked(hDlg,i) == 1)
            {
              ST[j].GPlotData = 1;
              gSelectedNumOfParameters++;
            }
            else
						{
              ST[j].GPlotData = 0;
						}
          }
          break;

				default:
					break;
      }
			break;

		default:
			break;
	}
}
