/*--------------------------------------------*/
/*  Do_YAxisDialog - Dialog fuer Y-Achse      */
/*  Dr. Rainer Sieger, Universitaet Bremen    */
/*  22.05.2002                                */
/*--------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Do_YAxisDialog.h"
#include "Dialog.h"

#include "CheckData.h"
#include "Color.h"
#include "CalcValue.h"
#include "SetMinMax.h"
#include "MinMax.h"
#include "Plotter.h"
#include "SetPlotData.h"

#include "replaceStr.h"
#include "CreateFormat.h"
#include "Font.h"

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

	CHOOSECOLOR cc;
	BOOL        fColorDialog;

	Str255      dLabel;
	float	      Ymin;
	float	      Ymax;
	float       TickInkrement;    
	float       Refline;
	float       resParameterWidth;    
	float       res;

	int         MinorMarks;
	int         LineWidth;
	int         ColumnWidth;
	int         AddNext;
	int         MSymbol;
	int         MSize;

	int         dFixedParameterWidth;
	int         dYAuto;
	int					dYReverseRange;
	int         dBothSide;
	int         dInside;
	int         dTicklines;
	int         dMTicklines;
	int         dMarker;
	int         dLines;
	int         dColorize;
	int         dHistocol;
	int         dHistolin;
	int         dHistoout;
	int         dLitho;
	int         dText;
	int         dComment;
	int         dBoundary;
	int         dOccurrence;
	int         dCourse;
	int					dParametername;
	int					dGroupname;

	int					dShowValid;
	int					dShowNotValid;
	int					dShowUnknown;
	int					dShowQuestionable;
	int         dShowMissingData;

	int         temp;
	int					IDC_Radio_1[maxRadio+1] = {0,IDC_ADD,IDC_PLOT,0};
	int					IDC_Radio_2[maxRadio+1] = {0,IDC_0_DEG,IDC_45_DEG,IDC_90_DEG};
	int					RadioButton;

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_ParameterAxisDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					iFormatStr[32]	= "%d";
	char					fFormatStr[32]	= "%.1f";
	char					cFormatStr[32]	= "";

	int						ItemNo					= Item[0].what;
	int						i								= 0;

	BOOL					err							= TRUE;
	static HWND		hMinorMarks 	  = NULL;
	static HWND		hEditMinorMarks = NULL;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
      InitParameterAxisDialog(hDlg, ItemNo);
			InitUpDownControl(hDlg,IDC_YMINORMARKS,1,100,MinorMarks,&hMinorMarks,&hEditMinorMarks);
      SetFocus(hDlg);
      return FALSE;
      break;

		case WM_VSCROLL :
		  if ((HWND) lParam == hMinorMarks) UpDown(hMinorMarks,wParam);
      return FALSE;
      break;
        
    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
          SetParameterAxis(hDlg, ItemNo);
          EndDialog (hDlg, TRUE);
          return TRUE;
		      break;

				case IDC_0_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 1);
          return TRUE;
		      break;

				case IDC_45_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 2);
          return TRUE;
		      break;

				case IDC_90_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 3);
          return TRUE;
		      break;

        case IDC_PARAMETERWIDTH :
          if (!(err = CheckValue(hDlg, IDC_PARAMETERWIDTH)))
            resParameterWidth = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Set, fFormatStr, resParameterWidth, err);
          else
            resParameterWidth = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Change, fFormatStr, resParameterWidth, err);
          return TRUE;
		      break;

        case IDC_YMIN :
          if (!(err = CheckValue(hDlg, IDC_YMIN)))
            Ymin = FloatDialog(hDlg, IDC_YMIN, Set, cFormatStr, Ymin, err);
          else
            Ymin = FloatDialog(hDlg, IDC_YMIN, Change, cFormatStr, Ymin, err);
          return TRUE;
		      break;

        case IDC_YMAX :
          if (!(err = CheckValue(hDlg, IDC_YMAX)))
            Ymax = FloatDialog(hDlg, IDC_YMAX, Set, cFormatStr, Ymax, err);
          else
            Ymax = FloatDialog(hDlg, IDC_YMAX , Change, cFormatStr, Ymax, err);
          return TRUE;
		      break;

        case IDC_REFLINE :
          if (!(err = CheckValue(hDlg, IDC_REFLINE)))
            Refline = FloatDialog(hDlg, IDC_REFLINE, Set, cFormatStr, Refline, err);
          else
            Refline = FloatDialog(hDlg, IDC_REFLINE, Change, cFormatStr, Refline, err);
          return TRUE;
		      break;

        case IDC_YTICKINCREMENT :
          if (!(err = CheckValue(hDlg, IDC_YTICKINCREMENT)))
            TickInkrement = FloatDialog(hDlg, IDC_YTICKINCREMENT, Set, cFormatStr, TickInkrement, err);
          else
            TickInkrement = FloatDialog(hDlg, IDC_YTICKINCREMENT , Change, cFormatStr, TickInkrement, err);
          return TRUE;
		      break;

        case IDC_YMINORMARKS :
          if (!(err = CheckValue(hDlg, IDC_YMINORMARKS)))
            MinorMarks = IntegerDialog(hDlg, IDC_YMINORMARKS, Set, iFormatStr, MinorMarks, err);
          else
            MinorMarks = IntegerDialog(hDlg, IDC_YMINORMARKS , Change, iFormatStr, MinorMarks, err);
          return TRUE;
		      break;

        case IDC_YAUTO :
          SetCheckButton(hDlg, IDC_YAUTO, Change, &dYAuto);
          return TRUE;
		      break;

        case IDC_YREVERSE :
          SetCheckButton(hDlg, IDC_YREVERSE, Change, &dYReverseRange);
          return TRUE;
		      break;

        case IDC_YBOTHSIDE :
          SetCheckButton(hDlg, IDC_YBOTHSIDE, Change, &dBothSide);
          return TRUE;
		      break;

        case IDC_YINSIDE :
          SetCheckButton(hDlg, IDC_YINSIDE, Change, &dInside);
          return TRUE;
		      break;

        case IDC_YTICKLINES :
          SetCheckButton(hDlg, IDC_YTICKLINES, Change, &dTicklines);
          return TRUE;
		      break;

        case IDC_MYTICKLINES :
          SetCheckButton(hDlg, IDC_MYTICKLINES, Change, &dMTicklines);
          return TRUE;
		      break;

        case IDC_FIXEDPARAMETER :
          SetCheckButton(hDlg, IDC_FIXEDPARAMETER, Change, &dFixedParameterWidth);
          return TRUE;
		      break;

        case IDC_GROUPNAMEON :
          SetCheckButton(hDlg, IDC_GROUPNAMEON, Change, &dGroupname);
          if (dGroupname > 0)
	          GroupTitles++;
          else
		        GroupTitles--;                         
          return TRUE;
		      break;
              
        case IDC_PARAMETERNAMEON :
          SetCheckButton(hDlg, IDC_PARAMETERNAMEON, Change, &dParametername);
          return TRUE;
		      break;
              
        case IDC_PRE :
          SetParameterAxis(hDlg, ItemNo);
          i = ItemNo;
          ItemNo--;
          
					while ((ItemNo > 1) && (ST[ItemNo].PlotData < 1))
						ItemNo--;
          
					if (ST[ItemNo].PlotData < 1) 
						ItemNo = i;
          
					InitParameterAxisDialog(hDlg, ItemNo);
          Item[0].what = ItemNo;
          return TRUE;
		      break;

        case IDC_POST :
          SetParameterAxis(hDlg, ItemNo);
          i = ItemNo;
          ItemNo++;

					while ((ItemNo < gNumOfParameters-1) && (ST[ItemNo].PlotData < 1))
						ItemNo++;
          
					if (ST[ItemNo].PlotData < 1)
						ItemNo = i;
          
					InitParameterAxisDialog(hDlg, ItemNo);
          Item[0].what = ItemNo;
          return TRUE;
		      break;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
		      break;

				default:
					break;
			}
			break;

    case WM_PAINT :
      break;

		default:
			break;
  }

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void InitParameterAxisDialog(HWND hDlg, int ItemNo)
{
	char  iFormatStr[32]	= "%d";
	char  fFormatStr[32]	= "%.1f";
	char	cFormatStr[32]	= "";

	int		dim							= 0;

	BOOL  err							= TRUE;

/*--------------------------------------------*/

	strcpy(cFormatStr, (char *) ST[ItemNo].FormatStr);
	replaceStr(cFormatStr, "%.","");
	replaceStr(cFormatStr, "f","");
	sscanf(cFormatStr,"%d",&dim);
	dim++;
	sprintf(cFormatStr,"%%.%df", dim);

	res               = (float) cxDpi/2.54f;
	resParameterWidth = (float) ST[ItemNo].ParameterWidth/res;
	NewColor          = ST[0].Color;

	TextDialog(hDlg, IDC_GROUPNAME, Set, (char *) C[ItemNo].GroupName);
	TextDialog(hDlg, IDC_YLABEL, Set, (char *) C[ItemNo].Header);

	Ymin                 = FloatDialog(hDlg, IDC_YMIN, Set, cFormatStr, ST[ItemNo].min, err);
	Ymax                 = FloatDialog(hDlg, IDC_YMAX, Set, cFormatStr, ST[ItemNo].max, err);
	Refline              = FloatDialog(hDlg, IDC_REFLINE, Set, cFormatStr, ST[ItemNo].Refline, err);
	TickInkrement        = FloatDialog(hDlg, IDC_YTICKINCREMENT, Set, cFormatStr, ST[ItemNo].Tick_Increment, err);
	resParameterWidth    = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Set, fFormatStr, resParameterWidth, err);
	MinorMarks           = IntegerDialog(hDlg, IDC_YMINORMARKS, Set, iFormatStr, ST[ItemNo].Minor_Ticks, err);

	dYAuto               = ST[ItemNo].SetDefaultRange;
	dYReverseRange			 = ST[ItemNo].ReverseRange;
	dBothSide            = ST[ItemNo].BothSide;
	dInside              = ST[ItemNo].Inside;
	dTicklines           = ST[ItemNo].Tickline;
	dMTicklines          = ST[ItemNo].Minor_Tickline;
	dFixedParameterWidth = ST[ItemNo].fixedParameterWidth;
	dParametername			 = ST[ItemNo].PlotParametername;
	dGroupname					 = ST[ItemNo].PlotGroupname;

	switch (ST[ItemNo].ParameterTextOrientation)
	{
		case 0:
			RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 1);
			break;

		case 45:
			RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 2);
			break;

		case 90:
			RadioButton = SetRadioButton(hDlg, 3, IDC_Radio_2, 3);
			break;

		default:
			break;
	}

	SetCheckButton(hDlg, IDC_YAUTO, 					Set, &dYAuto);
	SetCheckButton(hDlg, IDC_YREVERSE,				Set, &dYReverseRange);
	SetCheckButton(hDlg, IDC_YBOTHSIDE, 			Set, &dBothSide);
	SetCheckButton(hDlg, IDC_YINSIDE, 				Set, &dInside);
	SetCheckButton(hDlg, IDC_YTICKLINES, 			Set, &dTicklines);
	SetCheckButton(hDlg, IDC_MYTICKLINES, 		Set, &dMTicklines);
	SetCheckButton(hDlg, IDC_FIXEDPARAMETER, 	Set, &dFixedParameterWidth);
	SetCheckButton(hDlg, IDC_GROUPNAMEON,			Set, &dGroupname);
	SetCheckButton(hDlg, IDC_PARAMETERNAMEON,	Set, &dParametername);
}          

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void SetParameterAxis(HWND hDlg, int ItemNo)
{
char    iFormatStr[32]	= "%d";
char    fFormatStr[32]	= "%.1f";
char		cFormatStr[32]	= "";

BOOL    err							= TRUE;

/*--------------------------------------------*/

	TextDialog(hDlg, IDC_GROUPNAME, Change, (char *) C[ItemNo].GroupName);
	TextDialog(hDlg, IDC_YLABEL, Change, (char *) C[ItemNo].Header); 

	ST[ItemNo].min						= FloatDialog(hDlg, IDC_YMIN, Change, cFormatStr, Ymin, err);
	ST[ItemNo].max						= FloatDialog(hDlg, IDC_YMAX, Change, cFormatStr, Ymax, err);
	ST[ItemNo].Refline				= FloatDialog(hDlg, IDC_REFLINE, Change, cFormatStr, Refline, err);
	resParameterWidth					= FloatDialog(hDlg, IDC_PARAMETERWIDTH, Change, fFormatStr, resParameterWidth, err);
	ST[ItemNo].Tick_Increment	= FloatDialog(hDlg, IDC_YTICKINCREMENT, Change, cFormatStr, TickInkrement, err);
	ST[ItemNo].Minor_Ticks    = IntegerDialog(hDlg, IDC_YMINORMARKS, Change, iFormatStr, MinorMarks, err);

	strcpy((char *) ST[ItemNo].FormatStr, cFormatStr);

	ST[ItemNo].SetDefaultRange			= dYAuto;
	ST[ItemNo].ReverseRange					= dYReverseRange;
	ST[ItemNo].BothSide							= dBothSide;
	ST[ItemNo].Inside								= dInside;
	ST[ItemNo].Tickline							= dTicklines;
	ST[ItemNo].Minor_Tickline				= dMTicklines;
	ST[ItemNo].fixedParameterWidth	= dFixedParameterWidth;
	ST[ItemNo].PlotGroupname				= dGroupname;
	ST[ItemNo].PlotParametername		= dParametername;

	ST[ItemNo].ParameterWidth = (int) (resParameterWidth*res);

	if (ST[ItemNo].ParameterWidth < 0)
	{
		ST[ItemNo].ParameterWidth			= 0;
		ST[ItemNo].fixedParameterWidth = 0;
	}

	switch (RadioButton)
	{
		case 1:
			ST[ItemNo].ParameterTextOrientation = 0;
			break;

		case 2:
			ST[ItemNo].ParameterTextOrientation = 45;
			break;

		case 3:
			ST[ItemNo].ParameterTextOrientation = 90;
			break;

		default:
			break;
	}

	SetMinMax(-1);
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_ParameterOptionDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					iFormatStr[32]		= "%d";
	char					fFormatStr[32]		= "%.1f";
	char					cFormatStr[32]		= "";

	int						ItemNo						= Item[0].what;
	int						i									= 0;

	BOOL					err								= TRUE;

	static HWND   hCtrlBlock				= NULL;
	static HWND 	hMSize  	   			= NULL;
	static HWND   hEditMSize   			= NULL;
	static HWND 	hMSymbol 	   			= NULL;
	static HWND   hEditMSymbol 			= NULL;
	static HWND 	hLineWidth   			= NULL;
	static HWND   hEditLineWidth		= NULL;
	static HWND 	hColumnWidth   		= NULL;
	static HWND   hEditColumnWidth	= NULL;
	static HWND 	hAddNext		   		= NULL;
	static HWND   hEditAddNext			= NULL;

	static QualityFlags_in					= 0;
	static QualityFlags_out					= 0;
		 	 				
// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
      InitParameterOptionDialog(hDlg, ItemNo);
      hCtrlBlock = GetDlgItem(hDlg, IDC_SETCOLOR);
			InitUpDownControl(hDlg,IDC_ADDNEXT,0,20,AddNext,&hAddNext,&hEditAddNext);
			InitUpDownControl(hDlg,IDC_LINEWIDTH,1,20,LineWidth,&hLineWidth,&hEditLineWidth);
			InitUpDownControl(hDlg,IDC_TICKLINEWIDTH,1,100,ColumnWidth,&hColumnWidth,&hEditColumnWidth);
			InitUpDownControl(hDlg,IDC_MSIZE,1,20,MSize,&hMSize,&hEditMSize);
			InitUpDownControl(hDlg,IDC_MSYMBOL,1,10,MSymbol,&hMSymbol,&hEditMSymbol);
			QualityFlags_in = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;
      SetFocus(hDlg);
      return FALSE;
      break;

		case WM_VSCROLL :
		  if ((HWND) lParam == hAddNext) UpDown(hAddNext,wParam);
		  if ((HWND) lParam == hLineWidth) UpDown(hLineWidth,wParam);
		  if ((HWND) lParam == hColumnWidth) UpDown(hColumnWidth,wParam);
		  if ((HWND) lParam == hMSize) UpDown(hMSize,wParam);
		  if ((HWND) lParam == hMSymbol) UpDown(hMSymbol,wParam);
      return FALSE;
      break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
          SetParameterOption(hDlg, ItemNo);
					QualityFlags_out = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;

					if (QualityFlags_in != QualityFlags_out)
					{
            MinMax();
            SetMinMax(1);  	
          }	 

					EndDialog (hDlg, TRUE);
          return TRUE;
		      break;

        case IDC_SETCOLOR :
          if ((fColorDialog = ColorDialog(hDlg, &cc, Choose, &NewColor)))
          {
            PaintTheBlock (hCtrlBlock, cc.rgbResult);
						useColor = 1;
					}

					return TRUE;
		      break;

        case IDC_LINEWIDTH :
          if (!(err = CheckValue(hDlg, IDC_LINEWIDTH)))
            LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, LineWidth, err);
          else
            LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, LineWidth, err);
          return TRUE;
		      break;

        case IDC_TICKLINEWIDTH :
          if (!(err = CheckValue(hDlg, IDC_TICKLINEWIDTH)))
            ColumnWidth = IntegerDialog(hDlg, IDC_TICKLINEWIDTH, Set, iFormatStr, ColumnWidth, err);
          else
            ColumnWidth = IntegerDialog(hDlg, IDC_TICKLINEWIDTH, Change, iFormatStr, ColumnWidth, err);
          return TRUE;
		      break;

        case IDC_ADDNEXT :
          if (!(err = CheckValue(hDlg, IDC_ADDNEXT)))
            AddNext = IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, AddNext, err);
          else
            AddNext = IntegerDialog(hDlg, IDC_ADDNEXT, Change, iFormatStr, AddNext, err);
          return TRUE;
		      break;

        case IDC_MSYMBOL :
          if (!(err = CheckValue(hDlg, IDC_MSYMBOL)))
            MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, MSymbol, err);
          else
            MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, MSymbol, err);
          return TRUE;
		      break;

        case IDC_MSIZE :
          if (!(err = CheckValue(hDlg, IDC_MSIZE)))
            MSize   = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, MSize, err);
          else
            MSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, MSize, err);
          return TRUE;
		      break;

				case IDC_ADD :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio_1, 1);
          return TRUE;
		      break;

				case IDC_PLOT :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio_1, 2);
          return TRUE;
		      break;

        case IDC_MARKER :
          SetCheckButton(hDlg, IDC_MARKER, Change, &dMarker);
          return TRUE;
		      break;

        case IDC_LINES :
          SetCheckButton(hDlg, IDC_LINES, Change, &dLines);
          return TRUE;
		      break;

        case IDC_COLORIZE :
          SetCheckButton(hDlg, IDC_COLORIZE, Change, &dColorize);
          return TRUE;
		      break;

        case IDC_HISTOCOL :
          SetCheckButton(hDlg, IDC_HISTOCOL, Change, &dHistocol);
          return TRUE;
		      break;

        case IDC_HISTOLIN :
          SetCheckButton(hDlg, IDC_HISTOLIN, Change, &dHistolin);
          return TRUE;
		      break;

        case IDC_HISTOOUT :
          SetCheckButton(hDlg, IDC_HISTOOUT, Change, &dHistoout);
          return TRUE;
		      break;

        case IDC_TEXT :
          SetCheckButton(hDlg, IDC_TEXT, Change, &dText);
          return TRUE;
		      break;

        case IDC_LITHO :
          SetCheckButton(hDlg, IDC_LITHO, Change, &dLitho);
          return TRUE;
		      break;

        case IDC_BOUNDARY :
          SetCheckButton(hDlg, IDC_BOUNDARY, Change, &dBoundary);
          return TRUE;
		      break;

        case IDC_COMMENT :
          SetCheckButton(hDlg, IDC_COMMENT, Change, &dComment);
          return TRUE;
		      break;

        case IDC_OCCURRENCE :
          SetCheckButton(hDlg, IDC_OCCURRENCE, Change, &dOccurrence);
          return TRUE;
		      break;

        case IDC_COURSE :
          SetCheckButton(hDlg, IDC_COURSE, Change, &dCourse);
          return TRUE;
		      break;

        case IDC_SHOWVALID :
          SetCheckButton(hDlg, IDC_SHOWVALID, Change, &dShowValid);
          return TRUE;
		      break;

        case IDC_SHOWNOTVALID :
          SetCheckButton(hDlg, IDC_SHOWNOTVALID, Change, &dShowNotValid);
          return TRUE;
		      break;

        case IDC_SHOWUNKNOWN :
          SetCheckButton(hDlg, IDC_SHOWUNKNOWN, Change, &dShowUnknown);
          return TRUE;
		      break;

        case IDC_SHOWQUESTIONABLE :
          SetCheckButton(hDlg, IDC_SHOWQUESTIONABLE, Change, &dShowQuestionable);
          return TRUE;
		      break;

        case IDC_SHOWMISSVAL :
          SetCheckButton(hDlg, IDC_SHOWMISSVAL, Change, &dShowMissingData);
          return TRUE;
		      break;

        case IDC_GROUPNAMEON :
          SetCheckButton(hDlg, IDC_GROUPNAMEON, Change, &dGroupname);

					if (dGroupname > 0)
            GroupTitles++;
          else
            GroupTitles--;                         

					return TRUE;
		      break;
              
        case IDC_PARAMETERNAMEON :
          SetCheckButton(hDlg, IDC_PARAMETERNAMEON, Change, &dParametername);
          return TRUE;
		      break;
              
        case IDC_PRE :
          SetParameterOption(hDlg, ItemNo);
					QualityFlags_out = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;

					if (QualityFlags_in != QualityFlags_out)
					{
            MinMax();
            SetMinMax(1);  	
          }	 

					i = ItemNo;
          ItemNo--;

					while ((ItemNo > 1) && (ST[ItemNo].PlotData < 1)) 
						ItemNo--;
          
					if (ST[ItemNo].PlotData < 1) 
						ItemNo = i;
          
					InitParameterOptionDialog(hDlg, ItemNo);
					QualityFlags_in = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;
          Item[0].what = ItemNo;
        	PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].Color.red,ST[ItemNo].Color.green,ST[ItemNo].Color.blue));
          return TRUE;
		      break;

        case IDC_POST :
          SetParameterOption(hDlg, ItemNo);
					QualityFlags_out = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;

					if (QualityFlags_in != QualityFlags_out)
					{
            MinMax();
            SetMinMax(1);  	
          }	 

					i = ItemNo;
          ItemNo++;

					while ((ItemNo < gNumOfParameters-1) && (ST[ItemNo].PlotData < 1)) 
						ItemNo++;

					if (ST[ItemNo].PlotData < 1) 
						ItemNo = i;

					InitParameterOptionDialog(hDlg, ItemNo);
					QualityFlags_in = dShowValid + 2*dShowNotValid + 4*dShowUnknown + 8*dShowQuestionable + 16*dShowMissingData;
          Item[0].what = ItemNo;
        	PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].Color.red,ST[ItemNo].Color.green,ST[ItemNo].Color.blue));
          return TRUE;
		      break;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
		      break;
              
        case WM_KEYDOWN  :
          return TRUE;
		      break;
    
				default:
		      break;
      }
      break;

    case WM_PAINT :
			if (fColorDialog)
	      PaintTheBlock (hCtrlBlock, cc.rgbResult);
	    else  
	      PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].Color.red,ST[ItemNo].Color.green,ST[ItemNo].Color.blue));
      break;
      break;

		default:
			break;
  }
	
	return FALSE;
}


/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void InitParameterOptionDialog(HWND hDlg, int ItemNo)
{
	char        iFormatStr[32]	= "%d";
	char        fFormatStr[32]	= "%.1f";
	char				cFormatStr[32]	= "";

	int					dim							= 0;

	BOOL        err							= TRUE;

/*--------------------------------------------*/

	strcpy(cFormatStr, (char *) ST[ItemNo].FormatStr);
	replaceStr(cFormatStr, "%.","");
	replaceStr(cFormatStr, "f","");
	sscanf(cFormatStr,"%d",&dim);
	dim++;
	sprintf(cFormatStr,"%%.%df", dim);

  res               = (float) cxDpi/2.54f;
	resParameterWidth = (float) ST[ItemNo].ParameterWidth/res;
	NewColor          = ST[ItemNo].Color;

	TextDialog(hDlg, IDC_GROUPNAME, Set, (char *) C[ItemNo].GroupName);
  TextDialog(hDlg, IDC_YLABEL, Set, (char *) C[ItemNo].Header);

	fColorDialog	= ColorDialog(hDlg, &cc, Set, &NewColor);         
  LineWidth			= IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, ST[ItemNo].LineWidth, err);
  ColumnWidth		= IntegerDialog(hDlg, IDC_TICKLINEWIDTH, Set, iFormatStr, ST[ItemNo].ColumnWidth, err);
  MSymbol				= IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].MSymbol, err);
  MSize					= IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].MSize, err);

	if (ST[ItemNo].AddNext >= 0)
	{
    AddNext		 = IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, ST[ItemNo].AddNext, err);
		RadioButton = SetRadioButton(hDlg, 2, IDC_Radio_1, 1);
	}
	else
	{
    AddNext		 = IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, -ST[ItemNo].AddNext, err);
		RadioButton = SetRadioButton(hDlg, 2, IDC_Radio_1, 2);
	}

  dMarker      			= ST[ItemNo].PlotMarker;
  dLines       			= ST[ItemNo].PlotLine;
  dColorize    			= ST[ItemNo].Colorize;
  dHistocol    			= ST[ItemNo].PlotCHistogramm;
  dHistolin    			= ST[ItemNo].PlotLHistogramm;
  dHistoout    			= ST[ItemNo].PlotOHistogramm;
  dLitho						= ST[ItemNo].PlotLitho;
  dBoundary    			= ST[ItemNo].PlotBounds;
  dComment     			= ST[ItemNo].PlotComment;
  dText        			= ST[ItemNo].PlotText;
  dOccurrence  			= ST[ItemNo].PlotOccurrence;
  dCourse      			= ST[ItemNo].PlotCourse;
  dShowValid				= ST[ItemNo].ShowValid;
  dShowNotValid			= ST[ItemNo].ShowNotValid;
  dShowUnknown			= ST[ItemNo].ShowUnknown;
  dShowQuestionable	= ST[ItemNo].ShowQuestionable;
  dShowMissingData	= ST[ItemNo].ShowMissingData;
	dParametername		= ST[ItemNo].PlotParametername;
	dGroupname				= ST[ItemNo].PlotGroupname;

  SetCheckButton(hDlg, IDC_MARKER,						Set, &dMarker);
  SetCheckButton(hDlg, IDC_LINES,							Set, &dLines);
  SetCheckButton(hDlg, IDC_COLORIZE,					Set, &dColorize);
  SetCheckButton(hDlg, IDC_HISTOCOL,					Set, &dHistocol);
  SetCheckButton(hDlg, IDC_HISTOLIN,					Set, &dHistolin);
  SetCheckButton(hDlg, IDC_HISTOOUT,					Set, &dHistoout);
  SetCheckButton(hDlg, IDC_LITHO,							Set, &dLitho);
  SetCheckButton(hDlg, IDC_BOUNDARY,					Set, &dBoundary);
  SetCheckButton(hDlg, IDC_COMMENT,						Set, &dComment);
  SetCheckButton(hDlg, IDC_TEXT,							Set, &dText);
  SetCheckButton(hDlg, IDC_OCCURRENCE,				Set, &dOccurrence);
  SetCheckButton(hDlg, IDC_COURSE,						Set, &dCourse);
  SetCheckButton(hDlg, IDC_SHOWVALID,					Set, &dShowValid);
  SetCheckButton(hDlg, IDC_SHOWNOTVALID,			Set, &dShowNotValid);
  SetCheckButton(hDlg, IDC_SHOWUNKNOWN,				Set, &dShowUnknown);
  SetCheckButton(hDlg, IDC_SHOWQUESTIONABLE,	Set, &dShowQuestionable);
  SetCheckButton(hDlg, IDC_SHOWMISSVAL,				Set, &dShowMissingData);
  SetCheckButton(hDlg, IDC_GROUPNAMEON,				Set, &dGroupname);
  SetCheckButton(hDlg, IDC_PARAMETERNAMEON,		Set, &dParametername);
}          

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void SetParameterOption(HWND hDlg, int ItemNo)
{
	int					j								= 0;

	char        iFormatStr[32]	= "%d";
	char        fFormatStr[32]	= "%.1f";
	char				cFormatStr[32]	= "";

	BOOL        err							= TRUE;

/*--------------------------------------------*/

  TextDialog(hDlg, IDC_GROUPNAME, Change, (char *) C[ItemNo].GroupName);
  TextDialog(hDlg, IDC_YLABEL, Change, (char *) C[ItemNo].Header);

  if (fColorDialog)
	{
    fColorDialog  = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].Color);
	  Color[ItemNo] = ST[ItemNo].Color;
	  
		while (++j<=MAXNUMOFCOLORS)
		{
			if (!strcmp((char *) DColor[j].Name, (char *) C[ItemNo].Header))
				DColor[j].Flag = 0;

			if (DColor[j].Flag < 1)
			{
				DColor[j].Flag  = 1;
				DColor[j].Color = ST[ItemNo].Color;
				strcpy((char *) DColor[j].Name, (char *) C[ItemNo].Header);
				j = 2*MAXNUMOFCOLORS;
			}
		}
	}

  ST[ItemNo].LineWidth   = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, LineWidth, err);
  ST[ItemNo].ColumnWidth = IntegerDialog(hDlg, IDC_TICKLINEWIDTH, Change, iFormatStr, ColumnWidth, err);
  ST[ItemNo].AddNext     = IntegerDialog(hDlg, IDC_ADDNEXT, Change, iFormatStr, AddNext, err);
  ST[ItemNo].MSymbol     = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, MSymbol, err);
  ST[ItemNo].MSize       = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, MSize, err);

	if (ST[ItemNo].AddNext < 0)
		ST[ItemNo].AddNext = 0;	      

	if (RadioButton > 1)
		ST[ItemNo].AddNext = -ST[ItemNo].AddNext;

	if (ST[ItemNo].LineWidth < 1) 
		ST[ItemNo].LineWidth = 1;

  ST[ItemNo].PlotMarker      		= dMarker;
  ST[ItemNo].PlotLine        		= dLines;
  ST[ItemNo].Colorize        		= dColorize;
  ST[ItemNo].PlotCHistogramm 		= dHistocol;
  ST[ItemNo].PlotLHistogramm 		= dHistolin;
  ST[ItemNo].PlotOHistogramm 		= dHistoout;
  ST[ItemNo].PlotLitho					= dLitho;
  ST[ItemNo].PlotBounds      		= dBoundary;
  ST[ItemNo].PlotComment     		= dComment;
  ST[ItemNo].PlotText        		= dText;
  ST[ItemNo].PlotOccurrence  		= dOccurrence;
  ST[ItemNo].PlotCourse      		= dCourse;
  ST[ItemNo].ShowValid					= dShowValid;
  ST[ItemNo].ShowNotValid				= dShowNotValid;
  ST[ItemNo].ShowUnknown				= dShowUnknown;
  ST[ItemNo].ShowQuestionable		= dShowQuestionable;
  ST[ItemNo].ShowMissingData		= dShowMissingData;
  ST[ItemNo].PlotGroupname 			= dGroupname;
  ST[ItemNo].PlotParametername	= dParametername;

	if (SetPlotData(ItemNo) < 1)
		gSelectedNumOfParameters--;
}

