/*--------------------------------------------*/
/*  EnableMenu - Einschalten von Mens        */
/*  Dr. Rainer Sieger, Universitaet Bremen    */
/*  22.04.2001                                */
/*  Windows only                              */
/*--------------------------------------------*/

#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "EnableMenu.h"

/*--------------------------------------------*/

void EnableMenu (HWND hwnd, HMENU hMenu, HMENU hSubMenuFile, HMENU hSubMenuEdit, HMENU hSubMenuOptions, HMENU hSubMenuYAxis, HMENU hSubMenuSetAll)
{
	EnableMenuItem(hMenu, IDM_SAVEAS, MF_ENABLED);  		          // Save data as
	EnableMenuItem(hMenu, IDM_EXPORT, MF_ENABLED);			          // ExportPict
	EnableMenuItem(hMenu, IDM_PAGESETUP, MF_ENABLED);             // Page Setup
	EnableMenuItem(hMenu, IDM_PRINT, MF_ENABLED);                 // Print
	EnableMenuItem(hSubMenuFile, 12, MF_ENABLED | MF_BYPOSITION);	// Templates
	EnableMenuItem(hMenu, IDM_SAVEPREFS, MF_ENABLED);		          // Preferences

	EnableMenuItem(hMenu, 1,MF_ENABLED | MF_BYPOSITION);	        // Editmenue
	EnableMenuItem(hMenu, 2,MF_ENABLED | MF_BYPOSITION);	        // Optionmenue

	EnableEditMenu (hSubMenuEdit);

	if (gNumOfParameters > 1)
		EnableMenuItem(hSubMenuYAxis, 0, MF_ENABLED | MF_BYPOSITION);	// 
	else
		EnableMenuItem(hSubMenuYAxis, 0, MF_GRAYED  | MF_BYPOSITION);	// 

	if (gNumOfGroups > 1)
		EnableMenuItem(hSubMenuYAxis, 1, MF_ENABLED | MF_BYPOSITION);	// 
	else
		EnableMenuItem(hSubMenuYAxis, 1, MF_GRAYED  | MF_BYPOSITION);	// 

	switch (Mode)
	{
		case VerticalMode:
		case HorizontalMode:
			EnableMenuItem(hSubMenuOptions, 7, MF_ENABLED | MF_BYPOSITION);	// X Axis
			EnableMenuItem(hSubMenuSetAll,  0, MF_ENABLED | MF_BYPOSITION);	// Maximum axis length
			EnableMenuItem(hSubMenuSetAll,  1, MF_ENABLED | MF_BYPOSITION);	// Do with next
			EnableMenuItem(hSubMenuSetAll,  2, MF_ENABLED | MF_BYPOSITION);	// Parameter text orientation
			EnableMenuItem(hSubMenuSetAll,  3, MF_ENABLED | MF_BYPOSITION);	// Range
			EnableMenuItem(hSubMenuSetAll,  4, MF_ENABLED | MF_BYPOSITION);	// Ticks
			EnableMenuItem(hSubMenuSetAll,  5, MF_ENABLED | MF_BYPOSITION);	// Marker
			EnableMenuItem(hSubMenuSetAll,  6, MF_ENABLED | MF_BYPOSITION);	// Options
			EnableMenuItem(hSubMenuSetAll,  7, MF_ENABLED  | MF_BYPOSITION);	// Quality flags
			EnableMenuItem(hSubMenuSetAll,  8, MF_ENABLED | MF_BYPOSITION);	// Color
			EnableMenuItem(hSubMenuSetAll,  9, MF_ENABLED | MF_BYPOSITION);	// Line width
			EnableMenuItem(hSubMenuSetAll, 10, MF_ENABLED | MF_BYPOSITION);	// Column width
			EnableMenuItem(hSubMenuSetAll, 11, MF_GRAYED  | MF_BYPOSITION);	// Epsilon
			break;

		case TernaryMode:
			EnableMenuItem(hSubMenuOptions, 7, MF_GRAYED  | MF_BYPOSITION);	// X Axis
			EnableMenuItem(hSubMenuSetAll,  0, MF_GRAYED	| MF_BYPOSITION);	// Maximum axis length
			EnableMenuItem(hSubMenuSetAll,  1, MF_GRAYED	| MF_BYPOSITION);	// Do with next
			EnableMenuItem(hSubMenuSetAll,  2, MF_GRAYED  | MF_BYPOSITION);	// Parameter text orientation
			EnableMenuItem(hSubMenuSetAll,  3, MF_GRAYED  | MF_BYPOSITION);	// Range
			EnableMenuItem(hSubMenuSetAll,  4, MF_GRAYED  | MF_BYPOSITION);	// Ticks
			EnableMenuItem(hSubMenuSetAll,  5, MF_ENABLED | MF_BYPOSITION);	// Marker
			EnableMenuItem(hSubMenuSetAll,  6, MF_GRAYED  | MF_BYPOSITION);	// Options
			EnableMenuItem(hSubMenuSetAll,  7, MF_GRAYED  | MF_BYPOSITION);	// Quality flags
			EnableMenuItem(hSubMenuSetAll,  8, MF_ENABLED | MF_BYPOSITION);	// Color
			EnableMenuItem(hSubMenuSetAll,  9, MF_GRAYED  | MF_BYPOSITION);	// Line width
			EnableMenuItem(hSubMenuSetAll, 10, MF_GRAYED  | MF_BYPOSITION);	// Column width
			EnableMenuItem(hSubMenuSetAll, 11, MF_ENABLED | MF_BYPOSITION);	// Epsilon
			break;

		case PhaseMode:
			EnableMenuItem(hSubMenuOptions, 7, MF_GRAYED  | MF_BYPOSITION);	// X Axis
			EnableMenuItem(hSubMenuSetAll,  0, MF_GRAYED	| MF_BYPOSITION);	// Maximum axis length
			EnableMenuItem(hSubMenuSetAll,  1, MF_GRAYED	| MF_BYPOSITION);	// Do with next
			EnableMenuItem(hSubMenuSetAll,  2, MF_GRAYED  | MF_BYPOSITION);	// Parameter text orientation
			EnableMenuItem(hSubMenuSetAll,  3, MF_ENABLED | MF_BYPOSITION);	// Range
			EnableMenuItem(hSubMenuSetAll,  4, MF_GRAYED  | MF_BYPOSITION);	// Ticks
			EnableMenuItem(hSubMenuSetAll,  5, MF_GRAYED  | MF_BYPOSITION);	// Marker
			EnableMenuItem(hSubMenuSetAll,  6, MF_GRAYED  | MF_BYPOSITION);	// Options
			EnableMenuItem(hSubMenuSetAll,  7, MF_GRAYED  | MF_BYPOSITION);	// Quality flags
			EnableMenuItem(hSubMenuSetAll,  8, MF_ENABLED | MF_BYPOSITION);	// Color
			EnableMenuItem(hSubMenuSetAll,  9, MF_ENABLED | MF_BYPOSITION);	// Line width
			EnableMenuItem(hSubMenuSetAll, 10, MF_GRAYED  | MF_BYPOSITION);	// Column width
			EnableMenuItem(hSubMenuSetAll, 11, MF_GRAYED  | MF_BYPOSITION);	// Epsilon
			break;

		default:
			break;
	}

	DrawMenuBar(hwnd);
}      
      
/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void EnableEditMenu (HMENU hSubMenuEdit)
{
//    EnableMenuItem(hSubMenuEdit, IDM_UNDO, MF_ENABLED);  		   // Undo
//    EnableMenuItem(hSubMenuEdit, IDM_CUT, MF_ENABLED);				 // Cut
      EnableMenuItem(hSubMenuEdit, IDM_COPY, MF_ENABLED);				 // Copy
//    EnableMenuItem(hSubMenuEdit, IDM_PASTE, MF_ENABLED);       // Paste
//    EnableMenuItem(hSubMenuEdit, IDM_CLEAR, MF_ENABLED);       // Clear
}

