/*******************************************************************
*                                                                  *
*    ExportPicture.c -- Export einer Graphikdatei                  *
*                                                                  *
*    Dr. Rainer Sieger, AWI-Bremehaven, 04.09.97                   *
*    Windows only                                                  *
*                                                                  *
*******************************************************************/

#include <windows.h>
#include <winuser.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Plotter.h"
#include "ExportPicture.h"

#include "Graphic.h"

int ExportPicture(HWND hwnd, int Mode)
{
	HENHMETAFILE	hMetaFile = NULL;

	HDC						hRefDC;
	HDC						hdc;
	
	RECT					rect;
	int						iWidthMM, iHeightMM, iWidthPels, iHeightPels;
	int						iMMPerPelX, iMMPerPelY;

// ****************************************************************

  hRefDC = GetDC( hwnd );

// Compute the size of the client area in 0.01 mm.

  iWidthMM    = GetDeviceCaps(hRefDC, HORZSIZE);
  iHeightMM   = GetDeviceCaps(hRefDC, VERTSIZE);
  iWidthPels  = GetDeviceCaps(hRefDC, HORZRES);
  iHeightPels = GetDeviceCaps(hRefDC, VERTRES);

  iMMPerPelX = (iWidthMM * 100)/iWidthPels;
  iMMPerPelY = (iHeightMM * 100)/iHeightPels;

  GetClientRect(hwnd, &rect);

  rect.right  = (long) (rect.right * iMMPerPelX * 1.015);  // je grer desto mehr Rand
  rect.bottom = (long) (rect.bottom * iMMPerPelX * 1.015); // je grer desto mehr Rand
      
// Create an enhanced metafile.


	switch (Mode)
	{
		case TOCLIPBOARD:
			if ((hdc = CreateEnhMetaFile( hRefDC, NULL, &rect, "PanPlot Metafile" )))
			{
			  Plotter(hdc,Export);
		    hMetaFile = CloseEnhMetaFile( hdc );
			}
			break;

		case TOFILE:
			if ((hdc = CreateEnhMetaFile( hRefDC, (char *) PFullName, &rect, "PanPlot Metafile" )))
			{
			  Plotter(hdc,ExportToFile);
		    hMetaFile = CloseEnhMetaFile( hdc );
			}
			break;

		default:
			break;
	}

  if ( hdc )
	{
		if (Mode == TOCLIPBOARD)
		{
			OpenClipboard(hwnd);
			EmptyClipboard();
			SetClipboardData(CF_ENHMETAFILE,hMetaFile);
			CloseClipboard();
		}
	}

  ReleaseDC( hwnd, hRefDC );
  DeleteEnhMetaFile( hMetaFile );

  return(0);
}


