/*********************************************************************
*                                                                    *
*     MinMax                                                         *
*                                                                    *
*     Programmautor: Rainer Sieger, AWI-Bremerhaven                  *
*     Datei erstellt am: 3.4.95                                      *
*     Letzte Aenderung: 30.05.2002                                   *
*                                                                    *
*********************************************************************/

#include <math.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "SetMouseCursor.h"
#include "checkData.h"
#include "MinMax.h"
#include "CalcValue.h"

/********************************************************************/

float CalcDimension(float Value)
{
  float dim = (float) 0.;
  
  if (Value != 0.)
  {
    if (Value < 0.)  
      Value = -Value;

		while (Value > 10.)
    {
      Value /= (float) 10.;
      dim++;
    }  

		while (Value < 1.)
    {
      Value *= (float) 10.;
      dim--;
    }

		dim = (float) pow((float) 10., (double) dim);
  }

	return(dim);
}

/********************************************************************/
/********************************************************************/
/********************************************************************/

void MinMax (void)
{
	int    j = 0;

	unsigned long  i = 0;
	unsigned long  k = 0;

	float  data_dim  = (float) 0.;
	float  data_diff = (float) 0.;
	float  data_min  = (float) 0.;
	float  data_max  = (float) 0.;

	float  dim       = (float) 0.;
	float  diff      = (float) 0.;
	float  minimum   = (float) 0.;
	float  maximum   = (float) 0.;

	float  dummy     = (float) 0.;

	int		 iFormat   = 0;
			              
// ***********
// ***********

	SetWaitMouseCursor();

	for (j=0;j<=gNumOfParameters;j++)  
	{
		C[j].min = (float) 0.;
		C[j].max = (float) 0.;
	}
      
// ***********
// Abzisse

	minimum = min((float) 10E35,Q[1].V);
	maximum = max((float) -10E35,Q[1].V);

	sorted = 1;

	for (i=2;i<=C[0].counts;i++)
	{
			minimum = min(minimum,Q[i].V);
			maximum = max(maximum,Q[i].V);
			if (Q[i].V < Q[i-1].V)
				sorted = 0;
	}
	    
	if (minimum == maximum)
	{
		minimum -= (float) 1.;
		maximum += (float) 1.;
	}

	C[0].min = minimum;
	C[0].max = maximum;

	if ((fabs(C[0].min) < 0.3*fabs(C[0].max)) && (C[0].min*C[0].max > 0))
		C[0].min = (float) 0.;
		
// ***********
// Parameter

  for (j=1;j<=gNumOfParameters;j++)  
  {         
		if (!sorted)
		{
     	ST[j].PlotMarker      = 1;
 	   	ST[j].PlotLine        = 0;
 	   	ST[j].PlotCHistogramm = 0;
 	   	ST[j].PlotLHistogramm = 0;
 	   	ST[j].PlotOHistogramm = 0;     				
		}
		
    minimum  = (float)  10E35;
    maximum  = (float) -10E35;

    if (C[j].counts > 0)
    {
      k = C[j].Offset;
      for (i=k+1;i<=k+C[j].counts;i++)
      {
        if ((Q[i].I > 0) && (PlotDataFlag(j,Q[i].F) == 1)) 
        {
          minimum = min(minimum,Q[i].V);
          maximum = max(maximum,Q[i].V);
        }
      }
      
      if (minimum > 10E34)
	      minimum = (float) -1.;
      if (maximum < -10E34)
  	    maximum = (float)  1.;
    }   
    else
    {
      minimum = (float) -1.;
      maximum = (float)  1.;
    }

		data_min = minimum;
		data_max = maximum;

    if (minimum >= maximum)  
    {
      diff = CalcDimension((float) fabs(maximum))/(float) 10.;

			if (diff == 0)
        diff = (float) 1.;          	  

			minimum  = minimum - diff;
      maximum  = maximum + diff;
			data_min = minimum;
			data_max = maximum;
    }
		else
		{
	    if (maximum != 0)
		    maximum =  CalcDimension(maximum)*(float) 10.;  

			if (minimum != 0)  
				minimum = -CalcDimension(minimum)*(float) 10.;  
    
			if ((data_max < 0) && (maximum > 0))  
				maximum = (float) 0.;

			if ((data_min > 0) && (minimum < 0))  
				minimum = (float) 0.;

	    data_diff = data_max - data_min;
			
			if (data_min != 0.)
				data_min  = data_min - (float) 0.1*data_diff;

			if (data_max != 0.)
				data_max  = data_max + (float) 0.1*data_diff;

		  diff= maximum - minimum;
			dim	= CalcDimension(diff); 

			while ((dummy = minimum+dim) < data_min)
				minimum = dummy;

			while ((dummy = maximum-dim) > data_max)
				maximum = dummy;

			if (((maximum-minimum)/data_diff) > 2.)
			{
				minimum -= dim;
				maximum += dim;
				dim = CalcDimension(diff)/(float) 2.;

				while ((dummy = minimum+dim) < data_min)
					minimum = dummy;

				while ((dummy = maximum-dim) > data_max)
					maximum = dummy;
			}

			if (((maximum-minimum)/data_diff) > 2.)
			{
				minimum -= dim;
				maximum += dim;
				dim = CalcDimension(diff)/(float) 5.;

				while ((dummy = minimum+dim) < data_min)
					minimum = dummy;

				while ((dummy = maximum-dim) > data_max)
					maximum = dummy;
			}

			if (((maximum-minimum)/data_diff) > 2.)
			{
				minimum -= dim;
				maximum += dim;
				dim = CalcDimension(diff)/(float) 10.;

				while ((dummy = minimum+dim) < data_min)
					minimum = dummy;

				while ((dummy = maximum-dim) > data_max)
					maximum = dummy;
			}

			if (fabs(minimum-dim) < 0.01)
				minimum = (float) 0.;

			if (fabs(maximum+dim) < 0.01)
				maximum = (float) 0.;
		
			if ((maximum == 0.) && (minimum == 0.))
			{
				minimum = (float) -0.01;							
				maximum = (float)  0.01;
			}														

			if (data_min == 0.)
				minimum = (float) 0.;

			if (data_max == 0.)
				maximum = (float) 0.;
    }

    diff     = maximum - minimum;          
		dim	     = CalcDimension(diff); 
    data_dim = CalcDimension(data_diff);

		if (data_dim == 0.)
			data_dim = 1;

    if (dim/data_dim > 10)
    {          	
      C[j].min = data_min;
      C[j].max = data_max;
    }	
    else
    {          	
      C[j].min = minimum;
      C[j].max = maximum;
    }	
  }

	SetDefaultMouseCursor();
}      
