/*********************************************************************
*                                                                    *
*     PlotHistogrammColumn.c - Plot Histogrammsaeulen                *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen              *
*     Datei erstellt am: 10.02.98                                    *
*     Letzte Aenderung: 03.04.99                                     *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "PutText.h"
#include "Font.h"
#include "Graphic.h"
#include "CalcValue.h"

void PlotHistogramOutlineV(HDC hdc, int PlotMode, int j, int m, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  unsigned long  s     = 0;
  unsigned long  e     = 0;
  unsigned long  index = 0;

  int   l     = 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  int   pyo   = 0;
  int   pyu   = 0;
  int   nl    = 0;
  int   apx   = 0;
  int   apy   = 0;
  int   fpx   = 0;
  int   fpy   = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;
  
  int   PlotData   = 0;
  int   add				 = 0;

  float   dpy      = (float) 0.;
  float   Wert     = (float) 0.;
   
// ***********************************************

	SetWaitMouseCursor();

	P1  = C[j].P[1];
	P2  = C[j].P[2];
	P13 = P1+C[j].P[3];
	P24 = P2+C[j].P[4];
	nl  = (int) xinpx(C[j].K[1],C[j].K[2],ST[j].Refline);
	if (nl < P1)  nl = P1;
	if (nl > P13) nl = P13;

	while (--m >= 0)
	{
		if (ST[j].AddNext < 0)
			add = -m;                       
		else      
			add = m;                       

		if (ST[j+m].PlotOHistogramm > 0)
		{
			k = C[j+m].Offset;
			e = C[j+m].counts;

			i = 0;

			while (i < e)
			{
				s = 0;            

				while ((++i<=e) && (s < maxPTData-6))
				{
					Wert = CalcValue(i,j,add,&index,&PlotData);

					if ((Q[index].I > 0) && (PlotData == 1))
					{
						px  = (int) xinpx(C[j].K[1],C[j].K[2],Wert);

						if (Q[index].I >= 0)
							py  = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[index].I].V);

						if (s > 0)  
						{
							pyo = py - (py - apy)/2;
						}
						else
						{
							fpx = px;                   
							fpy = py;                  
							pyo = py;
						}  
	        
						if (px < P1+1)   px = P1;
						if (px > P13-1)  px = P13;
	      
						if ((py >= P2) && (py <= P24))
						{
							if (0 < s)
								SetPoint(++s, PT, apx, pyo);
						
							SetPoint(++s, PT, px, pyo);
							apx = px;                 
							apy = py;                 
						}  
						else
						{
							if (py > P24) 
								i = k + C[j+m].counts + 1;
						}
					}  
				}

				if (s < maxPTData-4)
				{
					SetPoint(0,   PT, fpx, fpy);
					SetPoint(++s, PT, apx, apy);
					SetPoint(++s, PT, nl, apy);
					SetPoint(++s, PT, nl, fpy);
					SetPoint(++s, PT, fpx, fpy);
					
					if (ST[j+m].Colorize > 0)
					{
						if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
						{
							CPlotFillPoly(hdc,PT,s,(int) F,GRAY);
					
							if (PlotMode != Export)
							{
								if (ST[j+m].PlotLine < 1)
									CPlotPolyline(hdc,PT,s,(int) F,BLACK);
								else
									CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,BLACK);                        
							}
						}
						else  
						{
							CPlotFillPoly(hdc,PT,s,(int) F,ST[j+m].Color);

							if (PlotMode != Export)
							{
								if (ST[j+m].PlotLine < 1)
									CPlotPolyline(hdc,PT,s,(int) F,BLACK);
								else
									CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,BLACK);
							}
						}
					}
					else 
					{
						if (PlotMode != Export)
							CPlotPolyline(hdc,PT,s-3,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
						else  
							CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
					}
				}
			}    
		}
	}

	SetDefaultMouseCursor();
}

// ***********************************************
// ***********************************************
// ***********************************************

void PlotHistogramOutlineH(HDC hdc, int PlotMode, int j, int m, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  unsigned long  s     = 0;
  unsigned long  e     = 0;
  unsigned long  index = 0;
  
  int   l     = 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  int   pxl   = 0;
  int   pxr   = 0;
  int   nl    = 0;
  int   apx   = 0;
  int   apy   = 0;
  int   fpx   = 0;
  int   fpy   = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;

  int   PlotData   = 0;
  int   add				 = 0;
  
  float   dpx      = (float) 0.;
  float   Wert     = (float) 0.;
    
// ***********************************************
    
	SetWaitMouseCursor();

	P1  = C[j].P[1];
	P2  = C[j].P[2];
	P13 = C[j].P[1]+C[j].P[3];
	P24 = C[j].P[2]+C[j].P[4];
	nl  = (int) yinpy(C[j].K[3],C[j].K[4],ST[j].Refline);
	if (nl > P2)  nl = P2;
	if (nl < P24) nl = P24;
	  
	while (--m >= 0)
	{
		if (ST[j].AddNext < 0)
			add = -m;                       
		else      
			add = m;                       

		if (ST[j+m].PlotOHistogramm > 0)
		{
			k = C[j+m].Offset;
			e = C[j+m].counts;

			i = 0;

			while (i < e)
			{
				s = 0;            
			
				while ((++i<=e) && (s < maxPTData-6))
				{
					Wert = CalcValue(i,j,add,&index,&PlotData);

					if ((Q[index].I > 0) && (PlotData == 1))
					{
						if (Q[index].I >= 0)
							px  = (int) xinpx(C[j].K[1],C[j].K[2],Q[Q[index].I].V);

						py  = (int) yinpy(C[j].K[3],C[j].K[4],Wert);

						if (s > 0)  
						{
							pxl = px - (px - apx)/2;
						}
						else
						{
							fpx = px;                   
							fpy = py;                  
							pxl = px;
						}  
	        
						if (py > P2+1)   py = P2;
						if (py < P24+1)  py = P24;
	      
						if ((px >= P1) && (px <= P13))
						{
							if (s > 0)
								SetPoint(++s, PT, pxl, apy);
						
							SetPoint(++s, PT, pxl, py);
							apx = px;                 
							apy = py;                 
						}  
						else
						{
							if (py > P24) i = k + C[j+m].counts + 1;
						}
					}  
				}

				if (s < maxPTData-4)
				{
					SetPoint(0,   PT, fpx, fpy);
					SetPoint(++s, PT, apx, apy);
					SetPoint(++s, PT, apx, nl);
					SetPoint(++s, PT, fpx, nl);
					SetPoint(++s, PT, fpx, fpy);
					
					if (ST[j+m].Colorize > 0)
					{
						if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
						{
							CPlotFillPoly(hdc,PT,s,(int) F,GRAY);
					
							if (PlotMode != Export)
							{
								if (ST[j+m].PlotLine < 1)
									CPlotPolyline(hdc,PT,s,(int) F,BLACK);
								else
									CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,BLACK);                        
							}
						}
						else  
						{
							CPlotFillPoly(hdc,PT,s,(int) F,ST[j+m].Color);

							if (PlotMode != Export)
							{
								if (ST[j+m].PlotLine < 1)
									CPlotPolyline(hdc,PT,s,(int) F,BLACK);
								else
									CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,BLACK);
							}
						}
					}
					else 
					{
						if (PlotMode != Export)
							CPlotPolyline(hdc,PT,s-3,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
						else  
							CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
					}
				}
			}  
		}
	}

	SetDefaultMouseCursor();
}


