/*********************************************************************
*                                                                    *
*     PlotP.c - Plot fuer Phasendarstellung                          *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 28.04.97                                    *
*     Letzte Aenderung: 06.01.2001                                   *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#include <math.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Graphic.h"
#include "Plotter.h"

void PlotP(HDC hdc)
{
  unsigned long  	i     = 0;
  unsigned long  	k     = 0;
  unsigned long  	k1    = 0;
  unsigned long  	k2    = 0;

  int     j     = 0;
	int     l     = 0;
	
	int			g 		= 0;

	int			l1, l2, lend;
	
	int     Ux    = 0;
	int 		Uy    = 0;
	int     b     = 0;
	int     h     = 0;

	int     px 		= 0;
	int			py 		= 0;

	int     x1    = 0;
	int     y1    = 0;
	int     x2    = 0;
	int     y2    = 0;
	
  int     GMSize     = 0;
  int     GLineWidth = 0;

  float   F   	= (float) 0.;
  
  float   P1    = (float) 0.;
  float   P2    = (float) 0.;

	float		b2		= (float) 0.;

	int			m[MAXNUMOFPARAMETERS + 1];
		
// ***********************************************

	SetWaitMouseCursor();

  F = (float) cxDpi/ScreenDpi;

	Ux    = C[0].P[1];
	Uy    = C[0].P[2];
	b     = C[0].P[3];
	h     = C[0].P[4];
	b2    = (float) b/(float) 2.;

  CCircle_outlined(hdc,Ux,Uy,(int) b2, KoorLineWidth*(int) F, BLACK);

  switch (SelectMode)
  {
   	case useGroups:
			l = 1;
		  for (j=1;j<=gNumOfGroups;j++)
		  {
        if ((ST[j].GRange == 0) && (l+1 <= MAXNUMOFPARAMETERS))
          ST[j].GRange = ST[l+1].max;

		    if ((ST[j].GPlotData > 0) && (l+1 <= MAXNUMOFPARAMETERS))
		    {
			      k   			 = C[l].Offset;
		        k1  			 = C[l].Offset;
		        k2  			 = C[l+1].Offset;
		        GLineWidth = ST[j].GLineWidth*(int) F;
		        
		        for (i=k+1;i<=k+C[l].counts;i++)
		        {
							k1++; k2++;
			        if ((Q[k1].I > 0) && (Q[k2].I > 0))
			        {
				        P1 = Q[k1].V;
					      P2 = Q[k2].V;
	
								CWinkel(hdc,P1,P2,ST[j].GRange,Ux,Uy,b2,GLineWidth,ST[j].GColor);
							}
		        }   
		    }
				l += C[j].NumOfParametersInGroup;
			}
			break;
			
		case useParameters:	
			for (j=0;j<=MAXNUMOFPARAMETERS;j++)
				m[j] = 0;				
				
			for (j=1;j<=gNumOfParameters;j++)
			{
				if (ST[j].PlotData > 0)
					m[++m[0]] = j;						
				else
					m[++m[0]] = 0;						
			}
					
			g = 0;
			l = 1;
			while (l<=m[0])
			{
				g++;
				lend = l+C[g].NumOfParametersInGroup-1;
				l1	 = l;
				l2   = 1;

				while ((m[l1] < l) && (l1 < lend))
					l1++;
				
				if (l1 < lend)
				{
					l2 = l1+1;
					while ((m[l2] < l) && (l2 <= lend))
						l2++;
					if (l2 <= lend)
					{
			      k  = C[m[l1]].Offset;
				    k1 = C[m[l1]].Offset;
						k2 = C[m[l2]].Offset;

		        if (ST[g].GRange == 0)
				      ST[g].GRange = ST[l2].max;

				    GLineWidth = (int) F * ST[g].GLineWidth;
				    
						for (i=k+1;i<=k+C[0].counts;i++)
						{
	         		k1++; k2++;
			        
							if ((Q[k1].I > 0) && (Q[k2].I > 0))
				      {
								P1 = Q[k1].V;
			          P2 = Q[k2].V;
	              
								CWinkel(hdc,P1,P2,ST[g].GRange,Ux,Uy,b2,GLineWidth,ST[g].GColor);
							}
						}
	        }   
				}

				l+=C[g].NumOfParametersInGroup;
			}
			break;		

		default:
			break;
	}

	SetDefaultMouseCursor();
}

