/*********************************************************************
*                                                                    *
*     PlotRGBColor.c - Plot von Farbsaeulen                          *
*                                                                    *
*     Programmautor: Rainer Sieger, AWI-Bremerhaven                  *
*     Datei erstellt am: 10.02.98                                    *
*     Letzte Aenderung: 26.11.2000                                   *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#define  RGBf  1.00;   // x*RGBf ==> 0-255 fr x=[0,255]

#include <string.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "Graphic.h"

void PlotRGBColorV(HDC hdc, float F)
{
  unsigned long  j     = 0;

  int   l     = 0;
  int   P2    = 0;
  int   P24   = 0;
  int   py    = 0;
  int   pyo   = 0;
  int   pyu   = 0;

	
	float red   = (float) 0.;
	float green = (float) 0.;
	float blue  = (float) 0.;
		  
// ***********************************************

  SetWaitMouseCursor();

  if (gNumOfComments > 0)
  {
    for (j=1;j<=gNumOfComments;j++)
    {
    	l = T[j].Parameter;

			if (ST[l].RGB > 0)
	    {
        P2  = pyo = C[l].P[2];
        P24 = pyu = P2+C[l].P[4];    		

        py = (int) yinpy(C[l].K[3],C[l].K[4],T[j].Depth);

				if (j > 1)
	        pyo = ((int) yinpy(C[l].K[3],C[l].K[4],T[j-1].Depth) + py)/2;

				if (j < gNumOfComments)	
	        pyu = (py + (int) yinpy(C[l].K[3],C[l].K[4],T[j+1].Depth))/2;
	        
        if (py <= P2-1)  
        	py = P2;

				if (py >= P24+1) 
        	py = P24;
        	
        if ((py >= P2) && (py <= P24))
				{
					sscanf((char *) T[j].Text,"%f/%f/%f", &red, &green, &blue);
          red   *= (float) RGBf;
          green *= (float) RGBf;
          blue  *= (float) RGBf;
					Color[l].red   = (unsigned char) red;
					Color[l].green = (unsigned char) green;
					Color[l].blue  = (unsigned char) blue;	

					if (ST[l].ColumnWidth > 0)
	        {
	          pyo = py - ST[l].ColumnWidth/2*(int) F;

						if (pyo <= P2-1)
	            pyo = P2;

						pyu = py + ST[l].ColumnWidth/2*(int) F; 

						if (pyu >= P24+1)
	            pyu = P24;
	        }

					CFillRechteck(hdc,C[l].P[1],pyo,C[l].P[1]+C[l].P[3],pyu,(int) F,Color[l]);
				}	
   		}		
   	}	
  }

	SetDefaultMouseCursor();
}

// ***********************************************
// ***********************************************
// ***********************************************

void PlotRGBColorH(HDC hdc, float F)
{
  unsigned long  j     = 0;

  int   l     = 0;
  int   P1    = 0;
  int   P13   = 0;
  int   px    = 0;
  int   pxl   = 0;
  int   pxr   = 0;
	
	float red   = (float) 0.;
	float green = (float) 0.;
	float blue  = (float) 0.;
		  
// ***********************************************
		
  SetWaitMouseCursor();

  if (gNumOfComments > 0)
  {
    for (j=1;j<=gNumOfComments;j++)
    {
    	l = T[j].Parameter;

			if (ST[l].RGB > 0)
	    {
        P1  = C[l].P[1];
        P13 = P1+C[l].P[3];    		
        px = (int) xinpx(C[l].K[1],C[l].K[2],T[j].Depth);
        if (px == P1-1)  px = P1;
        if (px == P13+1) px = P13;

				if ((px >= P1) && (px <= P13))
				{
					sscanf((char *) T[j].Text,"%f/%f/%f", &red, &green, &blue);
          red   *= (float) RGBf;
          green *= (float) RGBf;
          blue  *= (float) RGBf;
					Color[l].red   = (BYTE) red;
					Color[l].green = (BYTE) green;
					Color[l].blue  = (BYTE) blue;	

					if (ST[l].ColumnWidth > 0)
	        {
	          pxl = px - ST[l].ColumnWidth/2*(int) F;
	          pxr = px + ST[l].ColumnWidth/2*(int) F;
	        }
	        else
	        {
	          pxl = px - 1;
	          pxr = px + 1;
	        }

					CFillRechteck(hdc,pxl,C[l].P[2]+C[l].P[4],pxr,C[l].P[2],(int) F,Color[l]);
				}	
   		}		
   	}	
  }

	SetDefaultMouseCursor();
}


