/*********************************************************************
*                                                                    *
*     PlotV.c - Plot fuer Kerndarstellung                            *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 26.4.95                                     *
*     Letzte Aenderung: 22.05.2002                                   *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Dialog.h"
#include "SetMouseCursor.h"
#include "CheckData.h"
#include "CalcValue.h"
#include "Graphic.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "Font.h"
#include "PutText.h"

void PlotV(HDC hdc, int PlotMode)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  unsigned long  s     = 0;
  unsigned long  index = 0;
  unsigned long  e     = 0;
          
  int   j     = 0;
  int   l     = 0;
  int   m     = 0;
  int   add   = 0;

	int		Group = 0;
	
  int   px    = 0;
  int   py    = 0;
  int   pyo   = 0;
  int   pyu   = 0;
  int   nl    = 0;
  int   npx   = 0;
  int   npy   = 0;
  int   npx2  = 0;
  int   npy2  = 0;
  int   apx   = 0;
  int   apy   = 0;
  int   fpx   = 0;
  int   fpy   = 0;
  int   orgpx = 0;
  int   orgpy = 0;
  int   DLpx  = 0;
  int   DLpy  = 0;
      
  int   P1    = 0;
  int   P2    = 0;
  int   P3    = 0;
  int   P4    = 0;
  int   P13   = 0;
  int   P24   = 0;

  int   PlotData   = 0;

  int   PAbbruch   = 0;
  int   Abbruch    = 0;
  int   maxadd     = 0;
  int   Durchlauf  = 0;
  int   DL         = 0;
  int   Draw       = 1;
  int   clipRegion = 0;
  int   MSize      = 0;
  int   MLineWidth = 0;
	int   TextHeight = 0;
  
  float   k1       = (float) 0.;
  float   k2       = (float) 0.;
  float   k3       = (float) 0.;
  float   k4       = (float) 0.;

  float   S3       = (float) 0.;
  float   S4       = (float) 0.;

  float   Wert     = (float) 0.;
  float   dpy      = (float) 0.;
  
  float   F   		 = (float) 0.;

  Str15   Dummy;
	int     POS;
		    
// ***********************************************

  SetWaitMouseCursor();

  F = (float) cxDpi/ScreenDpi;

// ***********************************************

	PlotRGBColorV(hdc,F);
	PlotLithoV(hdc);
	PlotOccurrenceV(hdc,F);
	PlotBoundsV(hdc,F);
	PlotCourseV(hdc,F);
	PlotHistogramLineV(hdc,F);

// ***********************************************

    l = 0;
		j = 0;
    while (++j<=MAXNUMOFPARAMETERS)
    {
      if ((ST[j].PlotData > 0) && (C[j].counts > 0))
      {
        if (ST[j].AddNext < 0)
	        maxadd = -ST[j].AddNext;
  			else      
        	maxadd = ST[j].AddNext;
        
        if (maxadd > gNumOfParameters-j) 
				{
          maxadd = 0;
				}
        else  
        { 
          Durchlauf = 1;

          while ((Durchlauf == 1) && (maxadd >= 0))
					{
            if (C[j+maxadd].counts == 0)
              maxadd--;
            else
              Durchlauf = 0;
					}
        }

				m = maxadd + 1;

				PlotHistogramColumnV(hdc,PlotMode,j,m,F);
				PlotHistogramOutlineV(hdc,PlotMode,j,m,F);

        while (--m >= 0)
        {
	        if (ST[j].AddNext < 0)
	          add = -m;                       
  				else      
	          add = m;                       
                       
// *********
// * Wenn PlotLinie > 0

          if ((ST[j+m].PlotLine > 0) || ((ST[j+m].Colorize > 0) && (ST[j+m].PlotOHistogramm < 1)))
          {

// *********
// * Dummys initialisieren

            Durchlauf = 0;
          
						while(++Durchlauf <= 2)
            {
              Draw = 1; DL = 0;
              P1  = C[j].P[1]; P2  = C[j].P[2];
              P3  = C[j].P[3]; P4  = C[j].P[4];              
              P13 = P1+P3;     P24 = P2+P4;
              
              k1  = C[j].K[1]; k2  = C[j].K[2];
              k3  = C[j].K[3]; k4  = C[j].K[4];
              S3  = C[j].S[3]; S4  = C[j].S[4];
              
              nl  = (int) xinpx(k1,k2,ST[j].Refline);
              if (nl < P1+1)  nl = P1;
              if (nl > P13-1) nl = P13;
              fpx = nl; apx = nl; orgpx = nl;
              
              if ((P1 < nl) && (nl < P13) && ((PlotMode < 0) || (ST[j].Colorize > 0)))
              {
                if (Durchlauf == 1)
                {
                  P1 = nl;
                  P3 = P13 - P1;
                  S3 = ST[j].Refline;
                }
                else
                {
                  P13 = nl;
                  P3  = P13 - P1;
                  S4  = ST[j].Refline;
                }  
                k1 = P3/(S4-S3);
                k2 = k1*S3 - P1;
              }  
              else
							{
                Durchlauf = 100;
							}
              
              PAbbruch = 0;
              i        = 0;

              while ((i<=C[j+m].counts) && (!PAbbruch))
              {
                s = 0;
                
// * Startposition berechnen

                if (i < 1)
                {
                  Abbruch = 0;
              
									while ((++i<=C[j+m].counts) && (!Abbruch))
                  {
                    Wert = CalcValue(i,j,add,&index,&PlotData);
                      
                    npx = (int) xinpx(k1,k2,Wert);

										if (Q[index].I >= 0)
                      npy = (int) yinpy(k3,k4,Q[Q[index].I].V); 

										if (npy == P2-1)  
                      npy = P2;
                    
                    if ((P2 <= npy) && (npy <= P24) && (P1 <= npx) && (npx <= P13) && (PlotData == 1))
                    {
                      if (i == 1)
                      {
                        px    = npx;
                        py    = npy;
                        orgpx = npx;
                        orgpy = npy;
                      }  
                      else
                      {
                        px = npx;
                        py = npy;
                        if (orgpx < P1)
                          CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);
                        if (orgpx > P13)
                          CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);
                        if (py < P2)
                          CalcPx(orgpx,orgpy,npx,npy,P2,&px,&py);
                      } 

											fpx = px;
                      fpy = py;

                      if (px < P1) 
                      {
                        CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);
                        fpx = P1;
                      }

                      if (px > P13)
                      {
                        CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);
                        fpx = P13;
                      } 

                      apx     = npx;   //alte px
                      apy     = npy;   //alte py
                      orgpx   = npx;   //original px
                      orgpy   = npy;   //orginial py
                      Abbruch = 1;
                    }  
                    else
                    {
                      if ((i == 1) || (PlotData == 1)) 
                      {
                        orgpx = npx;
                        orgpy = npy;
                      }  
                    }  
                  }                         
                }
// ********
// * Die letzte Bremse
             
									
                if ((orgpy >= P24+1) || (i > C[j+m].counts))
								{
                  i = 2*C[j+m].counts;
								}
           			else
           			{
                	SetPoint(++s, PT, apx, apy);
	                i--; 
	              }  
  
// ********
// * Fuer alle Daten
              
                while ((++i <= C[j+m].counts) && (s < maxPTData-4))
                {
                  Wert = CalcValue(i,j,add,&index,&PlotData);
  
// * Wenn Datenpunkt geplottet werden soll
  
                  if (PlotData == 1)
                  {
                    npx = (int) xinpx(k1,k2,Wert);
                   
										if (Q[index].I >= 0)
											npy = (int) yinpy(k3,k4,Q[Q[index].I].V); 
    
                    if (DL == 1)
                    {
                      DL    = 0;
                      orgpx = DLpx;
                      orgpy = DLpy;
                    }                              
                  
// * Wenn Datenpunkt ausserhalb des Zeichenbereichs liegt
  
                    if ((P1-1 <= npx) && (npx <= P13+1))
                    {
                      if ((P1-1 <= orgpx) && (orgpx <= P13+1))
											{
                        clipRegion = 0;
											}
                      else
                      {
                        if (orgpx < P1)
                          clipRegion = 1;
                        else
                          clipRegion = 2;
                      }    
                    }      
                    else
                    {
                      if ((P1-1 <= orgpx) && (orgpx <= P13+1))
                      {
                        if (npx < P1)
                          clipRegion = 3;
                        else
                          clipRegion = 4;
                      }    
                      else
                      {
                        if (npx < P1)
                        {
                          if (orgpx < P1)
                            clipRegion = 5;
                          else
                            clipRegion = 6;
                        }    
                        else
                        {
                          if (orgpx < P1)
                            clipRegion = 7;
                          else
                            clipRegion = 8;
                        }    
                      }                            
                    }        
                    
                    
                    if (npy > P24+1)
                    {
                      clipRegion = 9;
                      i          = 2*C[j].counts;
                    }

                    if (npy < P2-1)
                    {
                      clipRegion = 12;
                      i          = 2*C[j].counts;
                    }
                    
                    if (i >= C[j].counts)
                      PAbbruch = 1;
                  } 

// *******
// * Linie zeichnen
  
                  switch (clipRegion)
                  {
                    case 0:
                      if (Draw == 1)
                        SetPoint(++s, PT, npx, npy);
                      else  
                        Draw = 1;
                      apx = npx;
                      break;
                    
                    case 1:
                      CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);
                      if (Draw == 1)
                      {
                        SetPoint(++s, PT, P1, py);
                        SetPoint(++s, PT, npx, npy);
                      }  
                      apx = npx;
                      break;
        
                    case 2:
                      CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);
                      if (Draw == 1)
                      {
                        SetPoint(++s, PT, P13, py);
                        SetPoint(++s, PT, npx, npy);
                      }  
                      apx = npx;
                      break;
                      
                    case 3:
                      CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);
                      if (Draw == 1)
                      {
                        SetPoint(++s, PT, P1, py);
                        SetPoint(++s, PT, P1, npy);
                      }  
                      apx = P1;
                      break;
        
                    case 4:
                      CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);
                      if (Draw == 1)
                      {
                        SetPoint(++s, PT, P13, py);
                        SetPoint(++s, PT, P13, npy);
                      }  
                      apx = P13;
                      break;
        
                    case 5:
                      if (Draw == 1)
                        SetPoint(++s, PT, P1, npy);
                      apx = P1;
                      break;
        
                    case 6:
                      CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);
                   
											if (Draw == 1)
                        SetPoint(++s, PT, P13, py);

											apy = py;
                      CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);

											if (Draw == 1)
                      {
                        SetPoint(++s, PT, P1, py);
                        SetPoint(++s, PT, P1, npy);
                      } 
                      apx = P1;
                      break;
        
                    case 7:
                      CalcPy(orgpx,orgpy,npx,npy,P1,&px,&py);

											if (Draw == 1)
                        SetPoint(++s, PT, P1, py);

											apy = py;
                      CalcPy(orgpx,orgpy,npx,npy,P13,&px,&py);

											if (Draw == 1)
                      {
                        SetPoint(++s, PT, P13, py);
                        SetPoint(++s, PT, P13, npy);
                      }  
                      apx = P13;
                      break;
        
                    case 8:
                      if (Draw == 1)
                        SetPoint(++s, PT, P13, npy);
                      apx = P13;
                      break;
                      
                    case 9:
                      CalcPx(orgpx,orgpy,npx,npy,P24,&px,&py);
                      if (px < P1)  px = P1; 
                      if (px > P13) px = P13; 

											if (Draw == 1)
                        SetPoint(++s, PT, px, P24);

											npy = P24;
                      apx = px;
                      break;
        
                    case 10:
                      break;
                          
                    case 11:
                      break; // hier wird nix gezeichnet
                      
                    case 12:
                      CalcPx(orgpx,orgpy,npx,npy,P2,&px,&py);
                      if (px < P1)  px = P1; 
                      if (px > P13) px = P13; 

											if (Draw == 1)
                        SetPoint(++s, PT, px, P2);

											npy = P2;
                      apx = px;
                      break;

										default: 
											break;
                  }  
                    
                  if (clipRegion < 10) 
                    Draw = 1;
                
                  apy   = npy;
                  orgpx = npx;
                  orgpy = npy;
                  
                } // Fuer alle Daten
  
                if (s <= maxPTData-3)
                {
                  SetPoint(0,   PT, fpx, fpy);
                  SetPoint(++s, PT, nl, apy);
                  SetPoint(++s, PT, nl, fpy);
                  SetPoint(++s, PT, fpx, fpy);
                  
                  fpx = apx;
                  fpy = apy;
                  
                  if (ST[j+m].Colorize > 0)
									{
                    if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
                    {
                      CPlotFillPoly(hdc,PT,s,(int) F,GRAY);
                      if (PlotMode != Export)
                      	if (ST[j+m].PlotLine < 1)
		                      CPlotPolyline(hdc,PT,s,(int) F,BLACK);
		                    else
		                      CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,BLACK);
                    }
                    else  
                    {
                      CPlotFillPoly(hdc,PT,s,(int) F,ST[j+m].Color);
                      if (PlotMode != Export)
                      	if (ST[j+m].PlotLine < 1)
		                      CPlotPolyline(hdc,PT,s,(int) F,BLACK);
		                    else
		                      CPlotPolyline(hdc,PT,s,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
                    }
									}
                  else
									{
                    CPlotPolyline(hdc,PT,s-3,ST[j+m].LineWidth*(int) F,ST[j+m].Color);
									}
                }
              } // Polygonzuege  
            } // Durchlauf
          }   // PlotLine oder Colorize

// ***********
// Marker

	        if (ST[j+m].PlotMarker > 0)
	        {
	          MSize      = (int) F * ST[j+m].MSize; 
	          MLineWidth = (int) F * ST[j+m].MLineWidth;
	
	          if ((ST[j+m].PlotLine > 0) 
	           || (ST[j+m].Colorize > 0) 
	           || (ST[j+m].PlotCHistogramm > 0)
	           || (ST[j+m].PlotOHistogramm > 0)
	           || (ST[j+m].PlotLHistogramm > 0))
	          {
	            P1  = C[j].P[1];
	            P2  = C[j].P[2];
	            P13 = P1+C[j].P[3];
	            P24 = P2+C[j].P[4];
	            
	            k = C[j+m].Offset;
	            
							for (i=1;i<=C[j+m].counts;i++)
	            {
				        Wert  = CalcValue(i,j,add,&index,&PlotData);
	            
								if ((Q[i+k].I > 0) && (PlotData == 1))
	              {
	                px = (int) xinpx(C[j].K[1],C[j].K[2],Wert);
	                py = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i+k].I].V);
	              
	                if (px == P1-1)  px = P1;
	                if (px == P13+1) px = P13;
	                if (py == P2-1)  py = P2;
	                if (py == P24+1) py = P24;

									if ((px >= P1) && (px <= P13) && (py >= P2) && (py <= P24))
	                  CPlotMarker(hdc,px,py,BLACK,MSize,MLineWidth,ST[j+m].MSymbol);
	                else
	                  if (py > P24) i = C[j+m].counts + 1;
	              }  
	            }  
	          }
	          else
	          {
	            P1  = C[j].P[1];
	 		        P2  = C[j].P[2];
	     		    P13 = C[j].P[1]+C[j].P[3];
	         		P24 = C[j].P[2]+C[j].P[4];
	            
	            k = C[j+m].Offset;

							for (i=1;i<=C[j+m].counts;i++)
	            {
				        Wert  = CalcValue(i,j,add,&index,&PlotData);

								if ((Q[i+k].I > 0) && (PlotData == 1))
	              {
	                px = (int) xinpx(C[j].K[1],C[j].K[2],Wert);
	                py = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i+k].I].V);
	              
	                if (px == P1-1)  px = P1;
	                if (px == P13+1) px = P13;
	                if (py == P2-1)  py = P2;
	                if (py == P24+1) py = P24;

									if ((px >= P1) && (px <= P13) && (py >= P2) && (py <= P24))
	                  CPlotMarker(hdc,px,py,ST[j+m].Color,MSize,MLineWidth,ST[j+m].MSymbol);
	                else
	                  if (py > P24) i = C[j+m].counts + 1;
	              }  
	            }  
	          }
	        }		// Plot Marker
        }     // Addition

// ***********
// Text

        if (ST[j].PlotText > 0)
        {
					i = 5;

        	while (FontSize-i < 1)
        		i--;

					// E. Grger
					i = 1;

					SetFont(hdc,(char *) Font,FontSize-(int) i,NORMAL,0);
   	  		TextHeight = FontHeight(hdc);
        	
          MSize = (int) F * ST[j].MSize; 

          if ((ST[j].PlotLine > 0) 
           || (ST[j].Colorize > 0) 
           || (ST[j].PlotMarker > 0) 
           || (ST[j].PlotCHistogramm > 0)
           || (ST[j].PlotOHistogramm > 0)
					 || (ST[j].PlotLHistogramm > 0))
          {
            P1  = C[j].P[1];
            P2  = C[j].P[2];
            P13 = C[j].P[1]+C[j].P[3];
            P24 = C[j].P[2]+C[j].P[4];
            
            k = C[j].Offset;

						for (i=k+1;i<=k+C[j].counts;i++)
						{
              if ((Q[i].I > 0) && (PlotDataFlag(j,Q[i].F) == 1))
              {
                px = (int) xinpx(C[j].K[1],C[j].K[2],Q[i].V)+7*MSize;
                py = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i].I].V)+TextHeight/2;
              
                if (px == P1-1)  px = P1;
                if (px == P13+1) px = P13;
                if (py == P2-1)  py = P2;
                if (py == P24+1) py = P24;
                if ((px >= P1) && (px <= P13) && (py >= P2) && (py <= P24))
                {
//                sprintf((char *) Dummy,"%.3f",Q[i].V);                

									// E. Grger
	                sprintf((char *) Dummy,"%.0f",Q[i].V);                

						      PutText(hdc,(char *) Dummy,px,py,TextHeight,LEFT);
						    }  
                else
                  if (py > P24) i = k + C[j].counts + 1;
              }  
						}
          }
          else
          {
            P1  = C[j].P[1];
 		        P2  = C[j].P[2];
         		P24 = C[j].P[2]+C[j].P[4];

         		if (ST[j].PlotOccurrence)
         		{
     		    	P13 = C[j].P[1]+C[j].P[3]/2+2*MSize;
     		    	POS = LEFT;
     		    }
     		    else
         		{
     		    	P13 = C[j].P[1]+C[j].P[3]/2;
     		    	POS = CENTER;
     		    }
     		    
            k = C[j].Offset;

            for (i=k+1;i<=k+C[j].counts;i++)
						{
              if ((Q[i].I > 0) && (PlotData == 1))
              {
                py = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i].I].V);
              
                if (py == P2-1)  py = P2;
                if (py == P24+1) py = P24;
                if ((py >= P2) && (py <= P24))
                {
//                sprintf((char *) Dummy,"%.3f",Q[i].V);                

									// E. Grger
	                sprintf((char *) Dummy,"%.0f",Q[i].V);                

									PutText(hdc,(char *) Dummy,P13,py+TextHeight/2,TextHeight,POS);
						    }  
                else
								{
                  if (py > P24) i = k + C[j].counts + 1;
								}
              }  
						}
          }
        }
        
// *********
// * FensterRahmen zeichnen
 
				CLinie(hdc,C[j].P[1],C[j].P[2],C[j].P[1],C[j].P[2]+C[j].P[4],KoorLineWidth*(int) F,BLACK);
		    CLinie(hdc,C[j].P[1],C[j].P[2]+C[j].P[4],C[j].P[1]+C[j].P[3],C[j].P[2]+C[j].P[4],KoorLineWidth*(int) F,BLACK);
			  CLinie(hdc,C[j].P[1]+C[j].P[3],C[j].P[2]+C[j].P[4],C[j].P[1]+C[j].P[3],C[j].P[2],KoorLineWidth*(int) F,BLACK);
				CLinie(hdc,C[j].P[1]+C[j].P[3],C[j].P[2],C[j].P[1],C[j].P[2],KoorLineWidth*(int) F,BLACK);

				if (++l >= gSelectedNumOfParameters)
					j = MAXNUMOFPARAMETERS;
      }       // PlotData > 0
    }         // gSelectedNumOfParameters

		SetDefaultMouseCursor();
	
		PlotCommentsV(hdc);
}

