/*********************************************************************
*                                                                    *
*     Plotter                                                        *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen              *
*     Datei erstellt am: 3.8.94                                      *
*     Letzte Aenderung: 03.04.99                                     *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Window.h"

#include "Plotter.h"

#include "Graphic.h"
#include "Font.h"
#include "PutText.h"

void Plotter(HDC hdc, int PlotMode)
{   
  if ((C[0].counts >= 1) && (gSelectedNumOfParameters > 0))
  {  
    switch (Mode)
    {
	    case VerticalMode:
				if (gSelectedNumOfParameters > 0) 
				{
					switch(PlotMode)
					{
						case Init:
							EraseWindow(gDataPlotWindow);
							SetScale();
							FontSize = SetPositionV(hdc);
							Umrechnungskonstanten();
							Koordinatensystem(hdc,PlotMode);
							PlotV(hdc,PlotMode);
							break;
				      
						case NoInit: 
							EraseWindow(gDataPlotWindow);
							Koordinatensystem(hdc,PlotMode);
							PlotV(hdc,PlotMode);
							break;
				      
						case Export:
						case ExportToFile:
		    			Koordinatensystem(hdc,PlotMode);
							PlotV(hdc,PlotMode);
							break;
				      
						case Print:	
							SetScale();
							FontSize = SetPositionV(hdc);
							Umrechnungskonstanten();
							Koordinatensystem(hdc,PlotMode);
							PlotV(hdc,PlotMode);
							break;

						default:
							break;
					}		      
				}
				break;
			
			case HorizontalMode:  
				if (gSelectedNumOfParameters > 0) 
				{
					switch (PlotMode)
					{
						case Init:
							EraseWindow(gDataPlotWindow);
							SetScale();
							FontSize = SetPositionH(hdc);
							Umrechnungskonstanten();
							Koordinatensystem(hdc,PlotMode);
							PlotH(hdc,PlotMode);
							break;
				      
						case NoInit: 
							EraseWindow(gDataPlotWindow);
							Koordinatensystem(hdc,PlotMode);
							PlotH(hdc,PlotMode);
							break;
				      
						case Export:
						case ExportToFile:
		    			Koordinatensystem(hdc,PlotMode);
							PlotH(hdc,PlotMode);
							break;
				      
						case Print:	
							SetScale();
							FontSize = SetPositionH(hdc);
							Umrechnungskonstanten();
							Koordinatensystem(hdc,PlotMode);
							PlotH(hdc,PlotMode);
							break;

						default:
							break;
					}		      
				}
				break;
			  
			case TernaryMode:  
		    switch (PlotMode)
		    {
		      case Init:
		        EraseWindow(gDataPlotWindow);
			      SetScale();
			      GFontSize = SetPositionT(hdc);
			      Umrechnungskonstanten();
			      Koordinatensystem(hdc,PlotMode);
			      PlotT(hdc);
			      break;
			      
			    case NoInit: 
		        EraseWindow(gDataPlotWindow);
			      Koordinatensystem(hdc,PlotMode);
			      PlotT(hdc);
			      break;
			      
		      case Export:
					case ExportToFile:
		    	  Koordinatensystem(hdc,PlotMode);
			      PlotT(hdc);
			      break;
			      
		      case Print:	
			      SetScale();
			      GFontSize = SetPositionT(hdc);
			      Umrechnungskonstanten();
			      Koordinatensystem(hdc,PlotMode);
			      PlotT(hdc);
			      break;

					default:
						break;
			  }		      
			  break;

			case PhaseMode:  
		    switch (PlotMode)
		    {
		      case Init:
		        EraseWindow(gDataPlotWindow);
			      SetScale();
			      GFontSize = SetPositionP(hdc);
			      Umrechnungskonstanten();
			      Koordinatensystem(hdc,PlotMode);
			      PlotP(hdc);
			      break;
			      
			    case NoInit: 
		        EraseWindow(gDataPlotWindow);
			      Koordinatensystem(hdc,PlotMode);
			      PlotP(hdc);
			      break;
			      
		      case Export:
					case ExportToFile:
		    	  Koordinatensystem(hdc,PlotMode);
			      PlotP(hdc);
			      break;
			      
		      case Print:	
			      SetScale();
			      GFontSize = SetPositionP(hdc);
			      Umrechnungskonstanten();
			      Koordinatensystem(hdc,PlotMode);
			      PlotP(hdc);
			      break;

					default:
						break;
			  }		      
			  break;

			default:
				break;
		}   
	}
  else
	{
    EraseWindow(gDataPlotWindow);  
	}
}      

