/*********************************************************************
*                                                                    *
*     Preferences                                                    *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 11.9.95                                     *
*     Letzte Aenderung: 11.06.2002                                   *
*                                                                    *
*********************************************************************/
      
#include <windows.h>
#include <string.h> 
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Fileselect.h"
#include "PrintTools.h"
#include "FileSystem.h"
#include "Initialize.h"
#include "Version.h"
#include "Color.h"
#include "CheckData.h"
#include "Preferences.h"
#include "replaceStr.h"
#include "SetMouseCursor.h"

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

void SetPreferences(void)
{
  int          j						 = 1;
  int          err					 = 1;

  StrFullName  prefsFileName = "";

  FILE				 *fd;

/*********************************************************************/
  
  
	if (gNumOfGroups > 1)
		SelectMode = useGroups;
	else
		SelectMode = useParameters;		  
		
  InitST();
   
  GetPrefName((char *) prefsFileName);
  
  if ((fd = openFile((char *) prefsFileName, "rb")) != NULL)
  {
    err = LoadPreferences(fd);
    closeFile(fd);;

		if (err)
      SavePreferences(0);        
  } 
  else
	{
    SavePreferences(0);
	}

  for (j=1;j<=gNumOfParameters;j++)
  {
  	if (ST[j].PlotData == 0)
  	{
  		if (C[j].counts > 0)
  		{
     		ST[j].PlotData        = 1;
     		ST[j].PlotMarker      = 1;
 	   		ST[j].PlotLine        = 1;
 	   		ST[j].PlotCHistogramm = 0;
 	   		ST[j].PlotLHistogramm = 0;
 	   		ST[j].PlotOHistogramm = 0;
 	   		ST[j].PlotComment     = 1; 	   		
   	 		ST[j].ShowValid	      = 1;
   	 		ST[j].ShowNotValid    = 0;
   			ST[j].MSymbol         = 1;
   		}
   		else
   		{
     		ST[j].PlotData        = 1;
     		ST[j].PlotComment     = 1;
     		ST[j].PlotMarker      = 0;
 	   		ST[j].PlotLine        = 0;
 	   		ST[j].PlotCHistogramm = 0;
 	   		ST[j].PlotLHistogramm = 0;
 	   		ST[j].PlotOHistogramm = 0;
   	 		ST[j].ShowValid	      = 1;
   	 		ST[j].ShowNotValid    = 0;
   			ST[j].MSymbol         = 1;
				ST[j].PlotLitho				= 0;		
				ST[j].PlotBounds			= 0;		
   		}	
   	}

 	  if ((C[j].counts > 250) && (ST[j].PlotLine > 0))
   		ST[j].PlotMarker = 0;
				
		if (ST[j].RGB > 0)
			ST[j].PlotComment = 0;						
	}
	
  for (j=gNumOfParameters+1;j<=MAXNUMOFPARAMETERS;j++)
  {
   	ST[j].PlotData            = 0;
   	ST[j].PlotMarker          = 0;
   	ST[j].PlotLine            = 0;
   	ST[j].PlotCHistogramm     = 0;
   	ST[j].PlotLHistogramm     = 0;
   	ST[j].PlotOHistogramm     = 0;
 		ST[j].PlotComment     		= 0;
   	ST[j].RGB						      = 0;
		ST[j].PlotLitho						= 0;		
		ST[j].PlotBounds					= 0;		
   	ST[j].ShowValid	          = 0;
   	ST[j].fixedParameterWidth = 0;
  }

  for (j=gNumOfParameters+1;j<=MAXNUMOFPARAMETERS;j++)
   	ST[j].MSymbol             = 1;

  for (j=1;j<=gNumOfGroups;j++)
  {
  	if (ST[j].GPlotData == 0) 
  	{
     	ST[j].GPlotData        	= 1;
   		ST[j].GMSymbol         	= 2;
   	}	
	}
     	
  for (j=gNumOfGroups+1;j<=MAXNUMOFPARAMETERS;j++)
   	ST[j].GPlotData          	= 0;

  for (j=gNumOfGroups+1;j<=MAXNUMOFPARAMETERS;j++)
   	ST[j].GMSymbol          	= 2;
  
  SetColor(MAXNUMOFPARAMETERS,Color,GColor,DColor,init);
  
	if ((useColor) && (useDefaultColor)) 
    SetColor(MAXNUMOFPARAMETERS,Color,GColor,DColor,set);
  else  
    SetBlack();

	if ((gNumOfGroups < 2) && (SelectMode == useGroups))
		SelectMode = useParameters;		    

	err = LoadWindowPreferences();

  SetDefaultMouseCursor();
}


/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

int LoadWindowPreferences(void)
{
  int						err						= -1;
  
  StrFullName		prefsFileName = "";
	
	char					InputStr[80];

  FILE					*fin;

/*********************************************************************/

  GetWindowPrefName((char *) prefsFileName);
  
/*********************************************************************/

	if ((fin = openFile((char *) prefsFileName, "rb")) != NULL)
  {
		if (readFile(fin,InputStr,79) == 0)  
		{
			closeFile(fin);
			return(-2);
		}	 

		if (strcmp((char *) InputStr, (char *) Version))
		{
			closeFile(fin);
			return(-3);
		}	 

		if (readFile(fin,InputStr,79) == 0)  
		{
			closeFile(fin);
			return(-4);
		}	 

		sscanf(InputStr,"%ld\t%ld",&gMaxCData,&gMaxMData);

		if (readFile(fin,InputStr,79) == 0)  
		{
			closeFile(fin);
			return(-5);
		}	 

		sscanf(InputStr,"%d\t%d\t%d\t%d",&gFrameWindowX,&gFrameWindowY,&gFrameWindowWidth,&gFrameWindowHeight);

		if (readFile(fin,InputStr,79) == 0)  
		{
			closeFile(fin);
			return(-6);
		}	 

		sscanf(InputStr,"%d\t%d\t%d\t%d",&gClientDataPlotWindowX,&gClientDataPlotWindowY,&gClientDataPlotWindowWidth,&gClientDataPlotWindowHeight);

		if (readFile(fin,InputStr,79) == 0)  
		{
			closeFile(fin);
			return(-7);
		}	 

		sscanf(InputStr,"%d\t%d\t%d\t%d",&gClientDataDescriptionWindowX,&gClientDataDescriptionWindowY,&gClientDataDescriptionWindowWidth,&gClientDataDescriptionWindowHeight);	 

		closeFile(fin);

		err = 0;
	}

	return(err);
}

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

int SaveWindowPreferences(void)
{
  StrFullName		prefsFileName = "";

	char					TempStr[80];

  FILE					*fout;

/*********************************************************************/

  GetWindowPrefName((char *) prefsFileName);

/*********************************************************************/
 
	if ( (gClientDataDescriptionWindowWidth < 0) || (gClientDataDescriptionWindowHeight < 0) || (gClientDataPlotWindowWidth < 0) || (gClientDataPlotWindowHeight < 0) )
		InitWindows();

/*********************************************************************/

	if ((fout = openNewFile((char *) prefsFileName)) != NULL)
  {
  	sprintf(TempStr,"%s\n",Version); writeFile(fout,TempStr);
		sprintf(TempStr,"%ld\t%ld\n",gMaxCData,gMaxMData); writeFile(fout,TempStr);
  	sprintf(TempStr,"%d\t%d\t%d\t%d\n",gFrameWindowX,gFrameWindowY,gFrameWindowWidth,gFrameWindowHeight); writeFile(fout,TempStr);  
  	sprintf(TempStr,"%d\t%d\t%d\t%d\n",gClientDataPlotWindowX,gClientDataPlotWindowY,gClientDataPlotWindowWidth,gClientDataPlotWindowHeight); writeFile(fout,TempStr);  
  	sprintf(TempStr,"%d\t%d\t%d\t%d\n",gClientDataDescriptionWindowX,gClientDataDescriptionWindowY,gClientDataDescriptionWindowWidth,gClientDataDescriptionWindowHeight); writeFile(fout,TempStr);  
	  closeFile(fout);;
  }

	return(0);
}

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

int LoadPreferences(FILE *fin)
{ 
	int     i						= 0;
	int     j						= 0;
	int     k						= 0;
	int		 len					= 0;
	int		 NumOfColors	= 0;
	int		 length				= 1;

	int     Dummy[40]; // Anzahl der Steuerparameter

	long    PVersion = 0;

	char    *p; 

/*--------------------------------------------*/
// ******
// Versionsnummer lesen

	SetWaitMouseCursor();

	if (readFile(fin,InputStr,MAXNUMOFCHAR) == 0)  
		return(-1);

// ******
// Versionsnummer vergleichen

	if (strcmp((char *) InputStr, (char *) Version))
		return(-2);
     
// ******
// 1. Zeile einlesen

	if (readFile(fin,InputStr,MAXNUMOFCHAR) == 0)  
		return(-1);
		
	if (readFile(fin,(char *) InputStr,MAXNUMOFCHAR) == 0)  
	{
		return(-1);
	}
	else
	{
		replaceStr((char *) InputStr,"Font: ","");
		memset ((char *) Font, (int) '\0', 32);
		strncpy((char *) Font,(char *) InputStr,31);
	}	

	if (readFile(fin,(char *) InputStr,MAXNUMOFCHAR) == 0)  
	{
		return(-1);
	}
	else
	{
		replaceStr((char *) InputStr,"Editor: ","");
		memset ((char *) Editor, (int) '\0', MAX_PATH + MAX_FNAME + 1);
		strncpy((char *) Editor,(char *) InputStr,MAX_PATH + MAX_FNAME);

		if (strlen((char *) Editor) > strlen((char *) EName))
	 		ChooseEditor = 1;
	}
	 	 	 	    
// ******
// 2. Zeile einlesen

   if (readFile(fin,InputStr,MAXNUMOFCHAR) == 0)  
		 return(-1);

// ******
// Parameter

	i = 1;

	if ((p = strchr(InputStr, (int) '\t')) != NULL)
	{
		if ((p-InputStr) > 0)
 	 		sscanf(InputStr, "%d", &Dummy[i++]); 
	}

	while (p != NULL)
	{
		strcpy(InputStr,p+1);

		if ((p = strchr(InputStr, (int) '\t')) != NULL)
		{
			if ((p-InputStr) > 0)
		 		sscanf(InputStr, "%d", &Dummy[i++]); 
		}
	}

	if (strlen((char *) InputStr) > 0)
 		sscanf(InputStr, "%d", &Dummy[i]); 

	if (Mode > 0)
 		Mode  = Dummy[1]; 	 	 
	else
		Mode += 10;

	useColor                   = Dummy[2];
	useDefaultColor            = Dummy[3];
	AllInOne                   = Dummy[4];
	ClipCoorSys                = Dummy[5];
	KoorLineWidth              = Dummy[6];	 
	WindowOffset               = Dummy[7]; 
	PlotAbsoluteScale          = Dummy[8];
	TerIncrement               = Dummy[9];	 
	FontSize                   = Dummy[10];	 
	GFontSize                  = Dummy[11];	 
	GroupDistance              = Dummy[12];
	SelectMode                 = Dummy[13];
	CRDateTime                 = Dummy[14];
	CRFilename                 = Dummy[15];
	UnitFormat                 = Dummy[16];
	TextOrientation						= 0;// Dummy[17];

// ******
// 3. Zeile einlesen

	if (readFile(fin,InputStr,MAXNUMOFCHAR) == 0)  
		return(-1);

	if ((p = strrchr((char *) Copyrighttext, (int) '@')) != NULL)
		*p = '\0';
	else
		strncpy((char *) Copyrighttext, InputStr, 255);
		 	
	while ((length > 0) && (k <= MAXNUMOFPARAMETERS))
	{
		SetWaitMouseCursor();
		length = readFile(fin,InputStr,MAXNUMOFCHAR);

		if ((p = strchr(InputStr, (int) '\n')) != NULL)
			*p = '\0';

		if (strlen((char *) InputStr) > 1)
		{
			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
				if ((p-InputStr) > 0)
			 		sscanf(InputStr, "%d", &j);
			}

			i = 1;
			
			while (p != NULL)
			{
				strcpy(InputStr,p+1);
				if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
						sscanf(InputStr, "%d", &Dummy[i++]); 
				}
			}

			if (strlen((char *) InputStr) > 0)
				sscanf(InputStr, "%d", &Dummy[i]); 
			
			ST[j].PlotData									= Dummy[1];
			ST[j].PlotMarker								= Dummy[2];
			ST[j].PlotLine									= Dummy[3];
			ST[j].PlotCHistogramm						= Dummy[4];
			ST[j].PlotLHistogramm						= Dummy[5];
			ST[j].PlotOHistogramm						= Dummy[6];
			ST[j].PlotLitho   							= Dummy[7];
			ST[j].PlotBounds   							= Dummy[8];
			ST[j].PlotText									= Dummy[9];
			ST[j].PlotOccurrence						= Dummy[10];
			ST[j].PlotCourse								= Dummy[11];
			ST[j].PlotComment								= Dummy[12];
			ST[j].ColumnWidth								= Dummy[13];
			ST[j].fixedParameterWidth				= Dummy[14];
			ST[j].ParameterWidth						= Dummy[15];		    
			ST[j].AddNext										= Dummy[16];
			ST[j].Colorize									= Dummy[17];		
			ST[j].ShowValid									= Dummy[18];
			ST[j].ShowNotValid							= Dummy[19];
			ST[j].ShowUnknown								= Dummy[20];
			ST[j].ShowQuestionable					= Dummy[21];
			ST[j].ShowMissingData						= Dummy[22];
			ST[j].ReverseRange		     			= Dummy[23];
			ST[j].BothSide									= Dummy[24];
			ST[j].Inside										= Dummy[25];
			ST[j].ParameterTextOrientation	= Dummy[26];
			ST[j].MSymbol										= Dummy[27];
			ST[j].MSize											= Dummy[28];
			ST[j].Minor_Ticks								= Dummy[29];
			ST[j].Tickline									= Dummy[30];
			ST[j].Minor_Tickline						= Dummy[31];
			ST[j].LineWidth									= Dummy[32];
			ST[j].GPlotData									= Dummy[33];
			ST[j].GMSymbol									= Dummy[34];
			ST[j].GMSize										= Dummy[35];
			ST[j].GLineWidth								= Dummy[36];
		}		  

		k++;
	}

	length = readFile(fin,InputStr,MAXNUMOFCHAR); // not used
	length = readFile(fin,InputStr,MAXNUMOFCHAR); // [Default color]

	j = -1;
   
	while ((length > 0) && (++j <= MAXNUMOFCOLORS))
	{
		length = readFile(fin,InputStr,MAXNUMOFCHAR);

		if ((p = strchr(InputStr, (int) '\n')) != NULL)
			*p = '\0';

		if (strlen((char *) InputStr) > 1)
		{
			DColor[j].Flag = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
				if ((len=(int) (p-InputStr)) > 0)
				{
					if (len>80)
						len = 80;

					memset((char *) DColor[j].Name,(int) '\0', 81);
			 		strncpy((char *) DColor[j].Name, InputStr, (unsigned int) len);
				}

				strcpy(InputStr,p+1);
			}

   		if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
				if ((p-InputStr) > 0)
					sscanf(InputStr, "%hu", &DColor[j].Color.red); 
			}

			strcpy(InputStr,p+1);

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
				if ((p-InputStr) > 0)
					sscanf(InputStr, "%hu", &DColor[j].Color.green); 
			}

			strcpy(InputStr,p+1);

			if (strlen(InputStr) > 0)
				sscanf(InputStr, "%hu", &DColor[j].Color.blue); 
		}
	}

	NumOfColors = j;

	if (UnitFormat == 1)
	{
		for (j=1;j<=NumOfColors;j++)
		{
			replaceStr((char *) DColor[j].Name,"[","(");
			replaceStr((char *) DColor[j].Name,"]",")");
		}
	}
	else
	{
		for (j=1;j<=NumOfColors;j++)
		{
			replaceStr((char *) DColor[j].Name,"(","[");
			replaceStr((char *) DColor[j].Name,")","]");
		}
	}

	if (UnitFormat == 1)
	{
		for (j=0;j<=gNumOfParameters;j++)
		{
			replaceStr((char *) C[j].Header,"[","(");
			replaceStr((char *) C[j].Header,"]",")");
		}
	}
	else
	{
		for (j=0;j<=gNumOfParameters;j++)
		{
			replaceStr((char *) C[j].Header,"(","[");
			replaceStr((char *) C[j].Header,")","]");
		}
	}

	SetDefaultMouseCursor();

	return(0);
}  

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/

void SavePreferences (int SaveMode)
{      
	FILE         *fout;

	int          j						 = 0;

	StrFullName  prefsFileName = "";

//------------------------------------------------------------

  SetWaitMouseCursor();

	GetPrefName((char *) prefsFileName);

	if ((fout = openNewFile((char *) prefsFileName)) != NULL)
  {
		strcpy((char *) DColor[0].Name, "TICK");
		sprintf(TempStr,"%s\n",Version); writeFile(fout,TempStr);
		sprintf(TempStr,"Version: %s\n",VersionNr); writeFile(fout,TempStr);
		sprintf(TempStr,"Font: %s\n",Font); writeFile(fout,TempStr);
		sprintf(TempStr,"Editor: %s\n",Editor); writeFile(fout,TempStr);			
		sprintf(TempStr,"%2d\t%d\t%d\t%d\t%d\t%d\t",Mode,useColor,useDefaultColor,AllInOne,ClipCoorSys,KoorLineWidth); writeFile(fout,TempStr);
		sprintf(TempStr,"%d\t%d\t%d\t",WindowOffset,PlotAbsoluteScale,TerIncrement); writeFile(fout,TempStr);
		sprintf(TempStr,"%d\t%d\t%d\t%d\t",FontSize,GFontSize,GroupDistance,SelectMode); writeFile(fout,TempStr);
		sprintf(TempStr,"%d\t%d\t%d\t%d\n",CRDateTime,CRFilename,UnitFormat,TextOrientation); writeFile(fout,TempStr);

		if (SaveMode > 0)
			sprintf(TempStr,"%s\n",Copyrighttext); 
		else
			sprintf(TempStr,"PANGAEA/PanPlot\n"); 

		writeFile(fout,TempStr);

		for (j=0;j<=MAXNUMOFPARAMETERS;j++)
		{
			sprintf(TempStr,"%2d\t",      j);																												writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t",  	ST[j].PlotData,    					ST[j].PlotMarker);						writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotLine,        			ST[j].PlotCHistogramm);				writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotLHistogramm, 			ST[j].PlotOHistogramm);				writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t",		ST[j].PlotLitho,						ST[j].PlotBounds);						writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotText,							ST[j].PlotOccurrence);				writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t", 	    ST[j].PlotCourse);																				writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t",   ST[j].PlotComment,					ST[j].ColumnWidth);						writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].fixedParameterWidth, 	ST[j].ParameterWidth);				writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t",		ST[j].AddNext, 		 					ST[j].Colorize);							writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].ShowValid,  					ST[j].ShowNotValid);					writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].ShowUnknown,  				ST[j].ShowQuestionable);			writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].ShowMissingData,			ST[j].ReverseRange);					writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].BothSide,   					ST[j].Inside);								writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t", 			ST[j].ParameterTextOrientation);													writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].MSymbol,      				ST[j].MSize);									writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].Minor_Ticks, 					ST[j].Tickline);							writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].Minor_Tickline,				ST[j].LineWidth);							writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\t", 	ST[j].GPlotData,						ST[j].GMSymbol);							writeFile(fout,TempStr);
			sprintf(TempStr,"%d\t%d\n", 	ST[j].GMSize,								ST[j].GLineWidth);						writeFile(fout,TempStr);
		}

		sprintf(TempStr,"%d\t%d\n", 0,0); writeFile(fout,TempStr);
		sprintf(TempStr,"[Default colors]\n"); writeFile(fout,TempStr);

		j = -1;

		while (++j<=MAXNUMOFCOLORS)
		{
			if (DColor[j].Flag)
			{
				sprintf(TempStr,"%s\t%hu\t",  DColor[j].Name,	       DColor[j].Color.red); writeFile(fout,TempStr);
				sprintf(TempStr,"%hu\t%hu\n",	DColor[j].Color.green, DColor[j].Color.blue); writeFile(fout,TempStr);
			}
			else
			{
				j = 2*MAXNUMOFCOLORS;
			}
		}

		closeFile(fout);    
  }

	SetDefaultMouseCursor();
}  
