/*********************************************************************
*                                                                    *
*     PrintPicture                                                   *
*                                                                    *
*     Programmautor: Rainer Sieger, AWI-Bremerhaven                  *
*     Datei erstellt am: 20.01.97                                    *
*     Letzte nderung: 11.11.2000                                    *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <winspool.h>
#include <wingdi.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Plotter.h"
#include "SetPapersize.h"
#include "Ezfont.h"

#include "Win_GUI.h"
#include "PrintPicture.h"
#include "PrintTools.h"
#include "SetMouseCursor.h"

#define   PrinterTest  0

BOOL PrintPicture (HWND hwnd, int PrintMode)
{
	HDC						hdc;
	HWND					nto_used = hwnd;
	
  int						oldWindowHeight = 0;
	int						oldWindowWidth	= 0;

	BOOL					bError = FALSE;
  DOCINFO       di = {sizeof(DOCINFO), "PanPlot", NULL};

  int           PaperWidth  = 0;
  int           PaperHeight = 0;

	int 					err = 0;
	
// ******************************************************************

	if (PrintMode == 1)
  {
	  psd.Flags = PSD_DISABLEMARGINS | PSD_INHUNDREDTHSOFMILLIMETERS;

		if (PageSetupDlg(&psd) == 0)
		  return 0;

		hdc = GetPrinterDC(psd);
  }
  else
  {
  	hdc = GetDefaultPrinterDC();
	}

	oldWindowHeight = gDataPlotWindowHeight;
	oldWindowWidth  = gDataPlotWindowWidth;
	
	if ((hdc) && (PrinterTest < 1)) 
	{
 	  GetLogicalResolution(hdc, TRUE, &cxDpi, &cyDpi);
    PaperWidth   = GetDeviceCaps (hdc, HORZRES);
    PaperWidth  -= (int) ((psd.rtMargin.left + psd.rtMargin.right)/254.0f);
    PaperHeight  = GetDeviceCaps (hdc, VERTRES);
    PaperHeight -= (int) ((psd.rtMargin.top + psd.rtMargin.bottom)/254.0f);

		PaperWidth	-= 100;
		PaperHeight	-= 100;

    dpcm         = (int) (cxDpi/2.54f);

		// Portrait
    SetPaperSize(PaperWidth, PaperHeight);

// Landscape
// SetPaperSize(PaperHeight, PaperWidth);

    SetMapMode(hdc, MM_ANISOTROPIC);

    if (StartDoc(hdc, &di) > 0)
    {
     	StartPage(hdc);
	 	  Plotter(hdc,Print);
				
//		Rectangle(hdc, 0,0,300,300);
				
   		EndPage(hdc);
	    EndDoc(hdc);
		}
		else
		{
			bError = TRUE;
		}

    DeleteDC(hdc);

		gDataPlotWindowHeight = oldWindowHeight;
		gDataPlotWindowWidth  = oldWindowWidth;
	
  	SetDefaultMouseCursor();
  	
		return bError;
	}

	return 0;
}

