/*********************************************************************
*                                                                    *
*     SetPosition                                                    *
*     Bildschirmkoordinaten der einzelnen Plots (14.9.95)            *
*                                                                    *
*     Programmautor: Dr. Rainer Sieger, AWI Bremerhaven		 	         *
*     Datei erstellt am: 13.11.95                                    *
*     Letzte Aenderung: 24.04.2001                                   *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"
#include "SplitHeader.h"
#include "Plotter.h"
#include "Font.h"
#include "floattostr.h"
#include "PutText.h"

int SetPositionH(HDC hdc)
{
	int     i											= 0;
	int     j											= 0;
	int     l											= 1;

	int			dummy									= 0;

	int     t_border							= 0;
	int     b_border							= 0;
	int     l_border							= 0;
	int     r_border							= 0;

	int     P1										= 0;
	int     P2										= 0;
	int     P3										= 0;
	int     P4										= 0;

	int     NumOfUnfixedPar				= 0;
	int			fixedParameterWidth		= 0;		
	int     ParameterWidth				= 0;
	int			maxyWidth							= 0;
	int			Scale									= 0;

	float   F											= (float) 0.;
	      
	Str31   Text									= "";
	Str31   minText								= "";
	Str31   maxText								= "";
	Str31   CmaxText							= "";

	Str80   Group									= "";
	Str80   Title									= "";
	Str80   Unit									= "";
						
// *****************************************************************************
// *****************************************************************************

	if (gSelectedNumOfParameters < 1)
		return(0);

// *****************************************************************************

	F	= (float) cxDpi/ScreenDpi;

// *****************************************************************************

	j = 0; l = 1;			

	while (++j<=MAXNUMOFPARAMETERS)  
	{
		if (ST[j].PlotData > 0)
		{
			if (ST[j].fixedParameterWidth < 1)
				NumOfUnfixedPar++;
			else
				fixedParameterWidth += ST[j].ParameterWidth;

			if (++l > gSelectedNumOfParameters)
			{
				sprintf((char *) CmaxText,(char *) ST[j].FormatStr,ST[j].max);
				strcat((char *) CmaxText,"W");
        j = MAXNUMOFPARAMETERS + 1;
			}
		}
	}

// ******

	Scale = CalcScale();
	SetFont(hdc,(char *) Font,FontSize+2,BOLD,0);
	GroupTitleHeight = FontHeight(hdc);

  SetFont(hdc,(char *) Font,FontSize,BOLD,0);
 	xTitleHeight  = FontHeight(hdc);
 	yTitleHeight  = FontHeight(hdc);

 	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
 	xUnitHeight		= FontHeight(hdc);
	xValueHeight	= FontHeight(hdc);
	yValueHeight	= FontHeight(hdc);
  yUnitHeight		= FontHeight(hdc);
 	InfoHeight		= FontHeight(hdc);
	HxValueHeight	= FontHeight(hdc)/2;

 	SetFont(hdc,(char *) Font,FontSize-4,NORMAL,0);
 	CopyrightHeight = FontHeight(hdc);

// *****************************************************************************
// calculate t_border      

	if (GroupTitles > 0)
		t_border = ROT  + xValueHeight/2 + GroupTitleHeight;
	else
		t_border = ROT  + xValueHeight/2;
			
// *****************************************************************************
// calculate b_border

  b_border = RUT + MSL + ATE + xValueHeight + ATE + xTitleHeight + ATE + InfoHeight;

// *****************************************************************************
// calculate l_border      

  SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);

	j  = 0; l = 1; yValueWidth = 0;			

	while (++j<=MAXNUMOFPARAMETERS)  
	{
		if (ST[j].PlotData > 0) 
		{
			sprintf((char *) Text,(char *) ST[j].FormatStr,ST[j].min);

			if ((dummy = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text))) > yValueWidth)
				yValueWidth = dummy;

			sprintf((char *) Text,(char *) ST[j].FormatStr,ST[j].max);

			if ((dummy = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text))) > yValueWidth)
				yValueWidth = dummy;

			if (++l > gSelectedNumOfParameters)
				j = MAXNUMOFPARAMETERS + 1;
		}
	}    

	maxyWidth = 0;			

	if (GroupTitles > 0)
	{
		SetFont(hdc,(char *) Font,FontSize+2,BOLD,0);

		for (j=2;j<=gNumOfParameters;j++)  
		{
			if ((ST[j].PlotData > 0) && (ST[j].PlotGroupname > 0))
			{
				if ((dummy = CalcTextWidth(hdc, (char *) C[j].GroupName,0,(int) strlen((char *) C[j].GroupName))) > maxyWidth)
					maxyWidth = dummy;
			}
		}
	}    

	SetFont(hdc,(char *) Font,FontSize,NORMAL,0);

	j  = 0; l = 1; 			

	while (++j<=MAXNUMOFPARAMETERS)  
	{
		if (ST[j].PlotData > 0) 
		{
			SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 

			if (ST[j].ParameterTextOrientation != 90)
			{
				strcat((char *) Title," "); strcat((char *) Title,(char *) Unit);

				if ((dummy = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title))) > maxyWidth)
					maxyWidth = dummy;
			}
			else
			{
				if ((dummy = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title))) > maxyWidth)
					maxyWidth = dummy;

				if ((dummy = CalcTextWidth(hdc, (char *) Unit,0,(int) strlen((char *) Unit))) > maxyWidth)
					maxyWidth = dummy;
			}

			if (++l > gSelectedNumOfParameters)
				j = MAXNUMOFPARAMETERS + 1;
		}
	}    

	if (GroupTitles > 0)
	{
		if (maxyWidth > 0)
			l_border = RLT + maxyWidth + ATE + yValueWidth + 2*ATE + MSL;
		else
			l_border = RLT + GroupTitleHeight + ATE + yTitleHeight + ATE + yUnitHeight + 2*ATE + yValueWidth + 2*ATE + MSL;
	}
	else
	{
		if (maxyWidth > 0)
			l_border = RLT + maxyWidth + ATE + yValueWidth + 2*ATE + MSL;
		else
			l_border = RLT + yTitleHeight + ATE + yUnitHeight + 2*ATE + yValueWidth + 2*ATE + MSL;
	}

// *****************************************************************************
// calculate r_border

  r_border = RRT;

// *****************************************************************************
// Set positions

	if ((NumOfUnfixedPar > 0) && (AllInOne == 0))
	{
		ParameterWidth     = gDataPlotWindowHeight - fixedParameterWidth - t_border - b_border;
		ParameterWidth    -= WindowOffset*(int) F*(gSelectedNumOfParameters-1);
		ParameterWidth    /= NumOfUnfixedPar;

		if (ParameterWidth < 0)
			ParameterWidth = 0;
	}

	if (AllInOne == 1)
		ParameterWidth = gDataPlotWindowHeight - t_border - b_border;

	if (TextOrientation == 0)
	{
		P1 = l_border;
		P2 = t_border;

		if (ST[0].fixedParameterWidth < 1)
			P3 = gDataPlotWindowWidth - l_border - r_border - 	Scale;
		else
			P3 = ST[0].ParameterWidth;

		P4 = ParameterWidth + WindowOffset*(int) F;

		C[0].P[1] = P1;
		C[0].P[3] = P3;

		j = 0; l = 1;			

		while (++j<=MAXNUMOFPARAMETERS)  
		{
			if (ST[j].PlotData > 0) 
			{
				if (AllInOne == 1)
				{
					C[j].P[1]  = P1;
       		C[j].P[2]  = P2 + ParameterWidth;
       		C[j].P[3]  = P3;
 	    		C[j].P[4]  = -ParameterWidth; 
				}
				else
				{
			  	if (ST[j].fixedParameterWidth < 1)
					{
						C[j].P[1]  = P1;
        		C[j].P[2]  = P2 + ParameterWidth;
        		C[j].P[3]  = P3;
   	    		C[j].P[4]  = -ParameterWidth; 
						P2  += P4;
					}
					else
					{
						C[j].P[1]  = P1;
        		C[j].P[2]  = P2 + ST[j].ParameterWidth;
        		C[j].P[3]  = P3;
   	    		C[j].P[4]  = -ST[j].ParameterWidth; 
						P2        += (ST[j].ParameterWidth + WindowOffset*(int) F);
					}
				}

				if (++l > gSelectedNumOfParameters)
					j = MAXNUMOFPARAMETERS + 1;
			}    
		}

		if (AllInOne == 0)
			C[0].P[2] = P2 - WindowOffset*(int) F;
		else
			C[0].P[2] = gDataPlotWindowHeight - b_border;
	}
	else
	{
		P1 = l_border;

		if (ST[0].fixedParameterWidth < 1)
			P3 = gDataPlotWindowWidth - l_border - r_border;
		else
			P3 = ST[0].ParameterWidth;

		P4 = ParameterWidth + WindowOffset*(int) F;
		P2 = gDataPlotWindowHeight - b_border + ParameterWidth;

		C[0].P[1] = P1;
		C[0].P[2] = gDataPlotWindowHeight - b_border;
		C[0].P[3] = P3;

		j = 0; l = 1;			

		while (++j<=MAXNUMOFPARAMETERS)  
		{
			if (ST[j].PlotData > 0) 
			{
				if (AllInOne == 1)
				{
					C[j].P[1]  = P1;
       		C[j].P[2]  = P2 - ParameterWidth;
       		C[j].P[3]  = P3;
 	    		C[j].P[4]  = -ParameterWidth; 
				}
				else
				{
			  	if (ST[j].fixedParameterWidth < 1)
					{
						C[j].P[1]  = P1;
        		C[j].P[2]  = P2 - ParameterWidth;
        		C[j].P[3]  = P3;
   	    		C[j].P[4]  = -ParameterWidth; 
						P2 -= P4;
					}
					else
					{
						C[j].P[1]  = P1;
        		C[j].P[2]  = P2 - ParameterWidth;
        		C[j].P[3]  = P3;
   	    		C[j].P[4]  = -ST[j].ParameterWidth; 
						P2        -= (ST[j].ParameterWidth + WindowOffset*(int) F);
					}
				}

				if (++l > gSelectedNumOfParameters)
					j = MAXNUMOFPARAMETERS + 1;
			}    
		}
	}

// *****************************************************************************
//		calculate CalcTextWidth

	SplitHeader((char *) C[0].Header, (char *) Group, (char *) Title, (char *) Unit); 

  SetFont(hdc,(char *) Font,FontSize,BOLD,0);
  xTitleWidth = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title));

  SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
  xUnitWidth = CalcTextWidth(hdc, (char *) Unit,0,(int) strlen((char *) Unit));

  BlankWidth = CalcTextWidth(hdc," ",0,1);

  return(FontSize);
}
      


