/***********************************************************************
*                                                                      *
*    Datei                                                             *
*      ShowStatusWindowMessages                                        *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*    Programmautor                                                     *
*      Dr. Rainer Sieger                                               *
*      Universitt Bremen, SFB261                                      *
*                                                                      *
************************************************************************
*                                                                      *
*    letztes Editierdatum                                              *
*      21.01.2001                                                      *
*                                                                      *
***********************************************************************/

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "ShowStatusWindowMessages.h"
#include "FindItem.h"

void ShowStatusWindowMessages(HWND hStatusWnd, int Mx, int My)
{
	char		XY[256]	=	"";

	float		x				= 0;
	float		y				= 0;
	float		z				= 0;

	int			ItemNo	= 0;

// *****************************************************************************

  ItemNo = FindItem(Mx,My);

	if ((ItemNo >= 1) && (ItemNo <= gNumOfParameters))
	{
		switch (Mode)
		{
			case VerticalMode :
				if ((C[ItemNo].P[2] <= My)  && (My <= C[ItemNo].P[2]+C[ItemNo].P[4]))
				{
					if (C[ItemNo].K[3] != 0)
						x = ((float) My + C[ItemNo].K[4])/C[ItemNo].K[3];
					if (C[ItemNo].K[1] != 0)
						y = ((float) Mx + C[ItemNo].K[2])/C[ItemNo].K[1];
					sprintf(XY,"%s: %.2f, %s: %.2f", C[0].Header, x, C[ItemNo].Header, y);
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) XY);
				}
				else
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) "");
				break;

			case HorizontalMode:
				if ((C[ItemNo].P[1] <= Mx)  && (Mx <= C[ItemNo].P[1]+C[ItemNo].P[3]))
				{
					if (C[ItemNo].K[1] != 0)
						x = ((float) Mx + C[ItemNo].K[2])/C[ItemNo].K[1];
					if (C[ItemNo].K[3] != 0)
						y = ((float) My + C[ItemNo].K[4])/C[ItemNo].K[3];
					sprintf(XY,"%s: %.2f, %s: %.2f", C[0].Header, x, C[ItemNo].Header, y);
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) XY);
				}
				else
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) "");
				break;

		  default:
			  SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) "");
				break;
		}
	}
	else
	{
		switch (Mode)
		{
			case TernaryMode:
				if (C[0].P[4] != 0)
					z = (C[0].P[2]-(float) My)/C[0].P[4];

				if (C[0].P[3] != 0)
					x = ((float) 2. - (float) 2.*((float) Mx-C[0].P[1])/C[0].P[3] - z)/(float) 2.;

				y = (float) 1. - x - z;				

				if ((x >= 0.) && (y >= 0.) && (z >= 0.) && (x+y+z <= 1.01))
				{
					sprintf(XY,"P1: %.2f%%, P2: %.2f%%, P3: %.2f%%", (float) 100.*x, (float) 100.*y, (float) 100.*z);
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) XY);
				}
				else
				  SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) "");
				break;

			case PhaseMode:
				x = (float) sqrt((double)((Mx-C[0].P[1])*(Mx-C[0].P[1])) + (double)((My-C[0].P[2])*(My-C[0].P[2])));
				y = (float) (asin((double)((Mx-C[0].P[1])/x))*57.29578);

				if (C[0].P[3] != 0)
					x = (float) 2.*x/C[0].P[3];

				if (x <= 1.)
				{
					if (My-C[0].P[2] > 0.)
						y = (float) 180. - y;

					if ((Mx-C[0].P[1] < 0.) && (My-C[0].P[2] < 0.))
						y = (float) 360. + y;

					sprintf(XY,"Length: %.2f, Angle: %.1f", x*ST[1].GRange, y);
					SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) XY);
				}
				else
				  SendMessage(hStatusWnd, SB_SETTEXT, 0, (LPARAM) "");
				break;

			default:
				break;
		}
	}
}

