/*********************************************************************
*                                                                    *
*     Umrechnungskonstanten                                          *
*                                                                    *
*     Programmautor: Rainer Sieger, AWI-Bremerhaven                  *
*     Datei erstellt am: 13.11.95                                    *
*     Letzte Aenderung: 04.05.98                                     *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <math.h>

#include "Win_GUI.h"

#include "Struct.h"
#include "Globals.h"

#include "Plotter.h"

void Umrechnungskonstanten (void)
{      
	int        i    = 0;
	int        j    = 0;

	int        px   = 0;
	int        py   = 0;

	float      pdy  = (float) 0.;
	float      pdx  = (float) 0.;

	float      xmax	= (float) 0.;
	float			 xmin	= (float) 0.;

// ****************************************************************

  xmax = Q[C[0].counts].V;        
    
	for (j=0;j<=gNumOfParameters;j++)  
	{
		for (i=0;i<=4;i++)  
      C[j].K[i] = (float) 0.;
	}

	switch (Mode)
  {
    case VerticalMode:
			for (j=1;j<=MAXNUMOFPARAMETERS;j++)  
			{
				if (ST[j].PlotData > 0)
		    {
					if ( ST[0].ReverseRange == 1 )
					{
						pdx = C[j].S[2]-C[j].S[1];
					
						if (pdx > 0)
							xmin = C[j].S[1];
						else
							xmin = C[j].S[2];
					}
					else
					{
						pdx = C[j].S[1]-C[j].S[2];

						if (pdx < 0)
							xmin = C[j].S[1];
						else
							xmin = C[j].S[2];
					}

					if (fabs(pdx) > 0)
					{
						C[j].K[3] = C[j].P[4]/pdx;
					  
						if (pdx > 0)
						{
							C[j].K[4] = C[j].K[3]*xmin - C[j].P[2];
						  
							py = (int) yinpy(C[j].K[3],C[j].K[4],xmax);

							if ((py < C[j].P[2]+C[j].P[4]) && (ClipCoorSys == 1))
							{
								C[j].P[4] = py - C[j].P[2];					          
								C[j].K[3] = C[j].P[4]/(xmax-xmin);
								C[j].K[4] = C[j].K[3]*xmin - C[j].P[2];
							}
						}
						else
						{
							C[j].K[4] = C[j].K[3]*xmin - (C[j].P[2]+C[j].P[4]);
						  
							py = (int) yinpy(C[j].K[3],C[j].K[4],xmax);

							if ((py < C[j].P[2]+C[j].P[4]) && (ClipCoorSys == 1))
							{
								C[j].P[4] = C[j].P[4] - (py - C[j].P[2]);					          
								C[j].K[3] = C[j].P[4]/(xmin-xmax);
								C[j].K[4] = C[j].K[3]*xmin - (C[j].P[2]+C[j].P[4]);
							}
						}
					}

					if ( ST[j].ReverseRange == 0 )		      
					{
						pdy = C[j].S[4]-C[j].S[3];

						if (fabs(pdy) > 0)
						{
							C[j].K[1] = C[j].P[3]/pdy;
							C[j].K[2] = C[j].K[1]*C[j].S[3] - C[j].P[1];
						}  
					}
					else
					{
						pdy = C[j].S[3]-C[j].S[4];

						if (fabs(pdy) > 0)
						{
							C[j].K[1] = C[j].P[3]/pdy;
							C[j].K[2] = C[j].K[1]*C[j].S[4] - C[j].P[1];
						}  
					}
		    }
			}
			break;
		      
    case HorizontalMode:
			for (j=1;j<=MAXNUMOFPARAMETERS;j++)  
			{
		    if (ST[j].PlotData > 0)
		    {
					if ( ST[0].ReverseRange == 0 )
					{
						pdx = C[j].S[2]-C[j].S[1];
					
						if (pdx > 0)
							xmin = C[j].S[1];
						else
							xmin = C[j].S[2];
					}
					else
					{
						pdx = C[j].S[1]-C[j].S[2];

						if (pdx < 0)
							xmin = C[j].S[1];
						else
							xmin = C[j].S[2];
					}

		      if (fabs(pdx) > 0)
		      {
			      C[j].K[1] = C[j].P[3]/pdx;
			      
			      if (pdx > 0)
			      {
				      C[j].K[2] = C[j].K[1]*xmin - C[j].P[1];
				      px = (int) xinpx(C[j].K[1],C[j].K[2],xmax);

							if ((px < C[j].P[1]+C[j].P[3]) && (ClipCoorSys == 1))
				      {
				        C[j].P[3] = px - C[j].P[1];					          
				        C[j].K[1] = C[j].P[3]/(xmax-xmin);
				        C[j].K[2] = C[j].K[1]*xmin - C[j].P[1];
				      }
				    }
				    else
			      {
				      C[j].K[2] = C[j].K[1]*xmin - (C[j].P[1]+C[j].P[3]);
				      px = (int) xinpx(C[j].K[1],C[j].K[2],xmax);

							if ((px < C[j].P[1]+C[j].P[3]) && (ClipCoorSys == 1))
				      {
				        C[j].P[3] = C[j].P[3] - (px - C[j].P[1]);					          
				        C[j].K[1] = C[j].P[3]/(xmin-xmax);
				        C[j].K[2] = C[j].K[1]*xmin - (C[j].P[1]+C[j].P[3]);
				      }
				    }				        
			    }  

					if ( ST[j].ReverseRange == 0 )		      
					{
						pdy = C[j].S[4]-C[j].S[3];

						if (fabs(pdy) > 0)
						{
							C[j].K[3] = C[j].P[4]/pdy;
							C[j].K[4] = C[j].K[3]*C[j].S[3] - C[j].P[2];
						}  
					}
					else
					{
						pdy = C[j].S[3]-C[j].S[4];

						if (fabs(pdy) > 0)
						{
							C[j].K[3] = C[j].P[4]/pdy;
							C[j].K[4] = C[j].K[3]*C[j].S[4] - C[j].P[2];
						}  
					}
		    }
			}
			break;

		default:
			break;
	}      
}      
