/* Dr. Rainer Sieger, Universitaet Bremen   /
/  letztes Editierdatum: 20.01.2001        */

#include <windows.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "Font.h"
#include "FindGroup.h"
#include "PutText.h"
#include "Plotter.h"
#include "SplitHeader.h"

void WriteParameterNameV(HDC hdc, int Scale)
{
	int			j			= 0;
	int     k			= 0;
	int			l			= 0;

	Str80   Group = "";
	Str80   Title = "";
	Str80   Unit  = "";

	int     vposP = 0;
	int     vposU = 0;

// *******************************************************************

	while (++j<=gNumOfParameters)
	{
		if ((ST[j].PlotData > 0) && (ST[j].PlotParametername > 0))
		{
			if (ST[j].ParameterTextOrientation == 0)
			{
				SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 

				vposU = C[j].P[2] - Scale - ATE - yValueHeight - ATE;

				if (strlen((char *) Unit) > 2)
				{
					SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
					PutText(hdc,(char *) Unit,(int) (C[j].P[1] + C[j].P[3]/2.),vposU,yUnitHeight,CENTER);
				}

				vposP = vposU - yUnitHeight - ATE;

				if (strlen((char *) Title) > 0)
				{
					SetFont(hdc,(char *) Font,FontSize,BOLD,0);
					PutText(hdc,(char *) Title,(int) (C[j].P[1] + C[j].P[3]/2.),vposP,yTitleHeight,CENTER);
				}
			}
			else
			{
				SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 
				
				strcat((char *) Title," "); strcat((char *) Title,(char *) Unit);

				if (strlen((char *) Title) > 1)
				{
					SetFont(hdc,(char *) Font,FontSize,NORMAL,ST[j].ParameterTextOrientation);

					if (ST[j].ParameterTextOrientation == 90)
						PutText(hdc,(char *) Title,(int) (C[j].P[1] + C[j].P[3]/10.),C[j].P[2]-Scale-2*ATE,yTitleHeight,LEFT);
					else
						PutText(hdc,(char *) Title,(int) (C[j].P[1] + C[j].P[3]/10.),C[j].P[2]-Scale-ATE-yUnitHeight,yTitleHeight,LEFT);
				}
			}

			if (AllInOne > 0)
				j = MAXNUMOFPARAMETERS;

			if (++l > gSelectedNumOfParameters) 
				j = MAXNUMOFPARAMETERS;
		}
	}

// Group name
  SetFont(hdc,(char *) Font,FontSize+2,BOLD,0);
	l = 0; j = 0;

	while (++j<=gNumOfParameters)
	{
		if ((ST[j].PlotData > 0) && (ST[j].PlotGroupname > 0))
		{
			PutText(hdc,(char *) C[j].GroupName,(int) (C[j].P[1] + C[j].P[3]/2.),GroupTitleHeight + ATE,GroupTitleHeight,CENTER);

			if (AllInOne > 0)
				j = MAXNUMOFPARAMETERS;

			if (++l > gSelectedNumOfParameters) 
				j = MAXNUMOFPARAMETERS;
		}
	}
}
