/* Dr. Rainer Sieger, Universitaet Bremen   /
/  letztes Editierdatum: 13.01.2000        */

#include <windows.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"
#include "Font.h"
#include "PutText.h"
#include "floattostr.h"
#include "Plotter.h"
#include "SplitHeader.h"
#include "Julday.h"
#include "replaceStr.h"

void WriteXAxisH(HDC hdc, int Scale)
{
	int			j						= 0;

	int     hpos        = 0;
	int     vpos				= 0;
	int			d						= 0;

	int     TitleWidth  = 0;
	int     UnitWidth   = 0;
	int     BlankWidth  = 0;

	float		F           = (float) 0.;
	float   maxDate  		= (float) 0.;			
	float   maxTime     = (float) 0.;

	Str80   Group       = "";
	Str80   Title       = "";
	Str80   Unit        = "";
	Str80   Dummy       = "";

	int		  Year				= 0;
	int		  Month				= 0;
	int		  Day   			= 0;      

	int		  Hour				= 0;
	int		  Minute			= 0;      
	int	 	  Second      = 0;
	      
	char    *p;

// *************************************************************

	F = (float) cxDpi/ScreenDpi;

	SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
	SplitHeader((char *) C[0].Header, (char *) Group, (char *) Title, (char *) Unit); 
	UnitWidth  = CalcTextWidth(hdc, (char *) Unit,0, (int) strlen((char *) Unit));

	SetFont(hdc,(char *) Font,FontSize,BOLD,0);
	TitleWidth = CalcTextWidth(hdc, (char *) Title,0, (int) strlen((char *) Title));

	BlankWidth = CalcTextWidth(hdc," ",0,1);

	hpos = C[0].P[1]+C[0].P[3]/2 - (TitleWidth+BlankWidth+UnitWidth)/2;
	vpos = C[0].P[2] + Scale + ATE + xValueHeight + ATE + xTitleHeight;

	PutText(hdc,(char *) Title,hpos,vpos,xTitleHeight,LEFT);
	SetFont(hdc,(char *) Font,FontSize,NORMAL,0);		
	PutText(hdc,(char *) Unit,hpos+TitleWidth+BlankWidth,vpos,xTitleHeight,LEFT);

	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);		

	sprintf((char *) Title, "max.: ");
      
	if (isDate)
	{
		maxDate = C[0].max + DateOffset;									
		CalcDate((long) floor((double) maxDate), &Year, &Month, &Day); 									
    sprintf((char *) Dummy,"%d-%02d-%02d",Year,Month,Day);					// ISO-Format
  }	

	if ((!isDate) && (isTime))
	{
		maxTime = C[0].max;
		CalcTime(maxTime, &Hour, &Minute, &Second); 									
    sprintf((char *) Dummy,": %02d:%02d:%02d",Hour,Minute,Second);							
  }	

	if ((!isDate) && (!isTime))
	{	
    floattostr(C[0].max, "%.1f*", (char *) Dummy);
		replaceStr((char *) Dummy, "0*", "*");
		replaceStr((char *) Dummy, ".*", "*");
		replaceStr((char *) Dummy, "*", "\0");				
    strcat((char *) Dummy, " ");
  }   

  strcat((char *) Title, (char *) Dummy);
      
  if (strlen((char *) Unit) > 2)
  {
    strcpy((char *) Dummy, (char *) Unit);

		if ((p = strstr((char *) Dummy, ")")) != NULL)
	  {
	    *p = (int) '\0';
		  memset((char *) Unit, '\0', 81);
		  p = strstr((char *) Dummy, "(");
      strcpy((char *) Unit, ++p);
    }  

		if ((p = strstr((char *) Dummy, "]")) != NULL)
	  {
	    *p = (int) '\0';
		  memset((char *) Unit, '\0', 81);
		  p = strstr((char *) Dummy, "[");
      strcpy((char *) Unit, ++p);
    }  

		strcat((char *) Title, (char *) Unit);
	}

	PutText(hdc,(char *) Title,C[0].P[1]+C[0].P[3],vpos,InfoHeight,RIGHT);
			
// Info and Copyright
	vpos += ATE + InfoHeight;
	memset((char  *) TempStr, '\0', MAXNUMOFCHAR+1);				
	
	d = CRFilename + 2*CRDateTime;

	switch (d)
	{
		case 1:
			strcat((char  *) TempStr, " ");
	  	strcat((char  *) TempStr, (char *) strCRFilename);
			break;

		case 2:
			strcat((char  *) TempStr, " ");
	  	strcat((char  *) TempStr, (char *) strCRDateTime);
			break;

		case 3:
			strcat((char  *) TempStr, " ");
	  	strcat((char  *) TempStr, (char *) strCRFilename);
			strcat((char  *) TempStr, " - ");
	  	strcat((char  *) TempStr, (char *) strCRDateTime);

		default:
			break;
	}		

	PutText(hdc,(char *) TempStr,C[0].P[1],vpos,InfoHeight,LEFT);

  SetFont(hdc,(char *) Font,FontSize-4,NORMAL,0);
  PutText(hdc,(char *) Copyrighttext,C[0].P[1]+C[0].P[3],vpos,CopyrightHeight,RIGHT);
}



