/* Dr. Rainer Sieger, Universitaet Bremen   /
/  letztes Editierdatum: 14.01.2000        */

#include <windows.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "Font.h"
#include "PutText.h"
#include "floattostr.h"
#include "Plotter.h"
#include "SplitHeader.h"
#include "Julday.h"
#include "replaceStr.h"

void WriteXAxisV(HDC hdc, int Scale)
{
	int			j						= 0;

	int     hpos        = 0;
	int     vpos				= 0;

	Str80   Group      = "";
	Str80   Title       = "";
	Str80   Unit				= "";
	Str80   Dummy       = "";

	int			Year				= 0;
	int			Month				= 0;
	int			Day   			= 0;      

	int			Hour				= 0;
	int			Minute			= 0;      
	int   	Second      = 0;
	      
	float   maxDate			= (float) 0.;			
	float   maxTime			= (float) 0.;			

	char    *p;

// *************************************************************

// calculate vpos
	j = MAXNUMOFPARAMETERS + 1;

	while (--j > 0)
	{
		if (ST[j].PlotData > 0)
		{
			vpos = C[j].P[2]+C[j].P[4]/2 + xTitleWidth/2 + BlankWidth/2 + yUnitWidth;
			j    = 0;
		}
	}

// calculate hpos
	j = 0;

	while (++j <= MAXNUMOFPARAMETERS)
	{
		if (ST[j].PlotData > 0)
		{
			hpos = C[j].P[1] - Scale - 2*ATE - xValueWidth - 2*ATE - xTitleHeight;
			j = MAXNUMOFPARAMETERS + 1;
		}
	}

// Header
  SplitHeader((char *) C[0].Header, (char *) Group, (char *) Title, (char *) Unit); 

// X-Title
	SetFont(hdc,(char *) Font,FontSize,BOLD,90);
 	PutTextR(hdc,(char *) Title, hpos, vpos, xTitleHeight,LEFT);
				
// X-Unit
  if (strlen((char *) Unit) > 2)
  {
	  SetFont(hdc,(char *) Font,FontSize,NORMAL,90);		
    vpos  = vpos - (xTitleWidth + BlankWidth);
 	  PutTextR(hdc,(char *) Unit,hpos,vpos,xTitleHeight,LEFT);
	}

// max
  SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
  sprintf((char *) Title, "max.: ");      
 	  
  j = 0;
  while (++j < MAXNUMOFPARAMETERS)
	{
    if (ST[j].PlotData > 0)
    {
      vpos = C[j].P[2]+C[j].P[4] + 2*xTitleHeight;
			hpos = C[j].P[1] - Scale - 2*ATE - xValueWidth - 2*ATE - xTitleHeight;
      j = MAXNUMOFPARAMETERS + 1;
		}
	}

	if (isDate)
	{
		maxDate = C[0].max + DateOffset;									
		CalcDate((long) floor((double) maxDate), &Year, &Month, &Day); 									
    sprintf((char *) Dummy,"%d-%02d-%02d",Year,Month,Day);							
  }	

	if ((!isDate) && (isTime))
	{
		maxTime = C[0].max;									
		CalcTime(maxTime, &Hour, &Minute, &Second); 									
    sprintf((char *) Dummy,"%02d:%02d:%02d",Hour,Minute,Second);							
  }	

	if ((!isDate) && (!isTime))
	{	
    floattostr(C[0].max, "%.1f*", (char *) Dummy);
		replaceStr((char *) Dummy, "0*", "*");
		replaceStr((char *) Dummy, ".*", "*");
		replaceStr((char *) Dummy, "*", "\0");				
    strcat((char *) Dummy, " ");
  }   

	strcat((char *) Title, (char *) Dummy);
      
  if (strlen((char *) Unit) > 2)
  {
    strcpy((char *) Dummy, (char *) Unit);

		if ((p = strstr((char *) Dummy, ")")) != NULL)
	  {
	    *p = (int) '\0';
		  memset((char *) Unit, '\0', 81);
		  p = strstr((char *) Dummy, "(");
      strcpy((char *) Unit, ++p);
    }  

		if ((p = strstr((char *) Dummy, "]")) != NULL)
	  {
	    *p = (int) '\0';
		  memset((char *) Unit, '\0', 81);
		  p = strstr((char *) Dummy, "[");
      strcpy((char *) Unit, ++p);
    }  

		strcat((char *) Title, (char *) Unit);
	}

	PutText(hdc,(char *) Title,hpos,vpos,InfoHeight,LEFT);
}
