/********************************/
/*                              */
/*  ReplaceString               */
/*  Dr. Rainer Sieger           */
/*  03.08.99                    */
/*                              */
/********************************/

#include <windows.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "replaceStr.h"

static int shift[256];
static int look_at;

void ts_init(char *p, int m);
int ts_search(char *text, char *SS, int m);

#define breakonfirstmatch 0

int replaceStr(char *Text, char *SS, char *RS)
{
  char  *p;
  
  int   match = 0;
  int   m     = 0;
  int		n			= 0;  
  int   pos   = 0;    
  
  if ((m = (int) strlen(SS)) > 3)
  {
    strcat(Text,SS);
    ts_init(SS,m);  

		for (;;)
    {
	    pos = ts_search(Text,SS,m);	    
    	n   = (int) strlen(Text) - m;    	

			if (pos > n-m)
    	{
	      p = Text+n;
	      *p = '\0';	      
    	  return(match);    	  
    	}  
    	else
    	{
	      match++;      
	      p = Text+pos;     	      
  	    strcpy(ReplaceTempStr,p+m);
    	  *p = '\0';

				if (strlen(Text) + strlen(RS) < MAXNUMOFCHAR)
        	strcat(Text,RS);

				if (strlen(Text) + strlen(ReplaceTempStr) < MAXNUMOFCHAR)
        	strcat(Text,ReplaceTempStr);
      }

			if ((breakonfirstmatch) && (match > 0))
				return(match);
    }
  }  
  else
  {
    while ((p = strstr(Text,SS)))
    {
      match++;    
      strcpy(ReplaceTempStr,p+m);
      *p = '\0';

			if (strlen(Text) + strlen(RS) < MAXNUMOFCHAR)
        strcat(Text,RS);

			if (strlen(Text) + strlen(ReplaceTempStr) < MAXNUMOFCHAR)
        strcat(Text,ReplaceTempStr);

			if ((breakonfirstmatch) && (match > 0))
				return(match);
    }

		return(match);      
  } 
}

// **********************************************************
// **********************************************************
// **********************************************************

void ts_init(char *p, int m)
{
  register int i  = 0;
  register int mm = m;
  
  mm++; 

	for (i=0;i<256;i++)
    shift[i] = mm;

	for (i=0;i<m;i++)
    shift[(unsigned char) p[i]] = m - i;
    
  mm      = m - 1;    
  look_at = 0;

	while (look_at < mm)  
  {
    if (p[mm] == p[m - (look_at+2)]) 
    	break;
    ++look_at;
  } 
}

// **********************************************************
// **********************************************************
// **********************************************************

int ts_search(char *text, char *p, int m)
{
  register int  mm = 0;           
  register int  i  = 0;
  register char *t = text;
  
  mm = m - 1;
  
  for (;;)
  {
    i = mm;
    while (t[i] != p[i])
      t += shift[(unsigned char) t[m]];
      
    i--;
    while (t[i] == p[i])
      if (--i < 0)
        return((int) (t-text));
        
    t += look_at + shift[(unsigned  char) t[m+look_at]];
  }
} 

