/*******************************************************************
*                                                                  *
*    ANSIConverter.c - EOL und ASCII Konvertierung                 *
*                                                                  *
*    Dr. Rainer Sieger, Universitaet Bremen, 10.09.99              *
*                                                                  *
*******************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <Windows.h>

#include "struct.h"
#include "globals.h"

#include "Win_FileSystem.h"
#include "ANSIConverter.h"
#include "ReadDataLine.h"
#include "SetMouseCursor.h"

// ********************

int MacToWin(char *FilenameIn, char *FilenameOut)
{
  int                 i       = 0;
  int                 l       = 0;  
  int                 length  = 0;
     
  char                p[2] 		= "";
  char                *t; 

  FILE    *fin;
  FILE    *fout;

  int                 TabMacOStoWin[256];

// ********************

  SetDefaultMouseCursor();

  if ((fin = openFile((char *) FilenameIn, "rb")) == NULL) 
		return(-1);
  if ((fout = openNewFile((char *) FilenameOut)) == NULL) 
  {
  	fclose(fin); 
		return(-2);  
  }

  InitTable(1,TabMacOStoWin);
  
  while((length = readFile(fin,InputStr,MAXNUMOFCHAR)) > 0)
  {
    SpinMouseCursor();
    
    t = InputStr; 
    l = (int) strlen(InputStr);
    
    while (l > 0)   
    {
      i = 128; 
      strncpy(p,t,1);      
      while(i<256)  
      {
        if (strchr(p,i))
        {
          *t = (char) TabMacOStoWin[i];
          i  = 999;
        }
        else
          i++;
      }   
      t++;      
      l--;      
    }
    fprintf(fout,"%s\x0A",InputStr);    
  }
 	fclose(fin); 
 	fclose(fout); 

  SetDefaultMouseCursor();

  return(0);
}

// ********************
// ********************    
// ********************

int WinToMac(char *FilenameIn, char *FilenameOut)
{
  int                 i       = 0;
  int                 l       = 0;  
  int                 length  = 0;
      
  char                p[2] 		= "";
  char                *t; 
			
  FILE    *fin;
  FILE    *fout;

  int                 TabWintoMacOS[256];
    
// ********************

  SetDefaultMouseCursor();
  if ((fin = openFile((char *) FilenameIn, "rb")) == NULL) 
		return(-1);
  if ((fout = openNewFile((char *) FilenameOut)) == NULL)
  {
  	fclose(fin); 
		return(-2);  
  }
    
  InitTable(2,TabWintoMacOS);
    
  while((length = readFile(fin,InputStr,MAXNUMOFCHAR)) > 0)
  {
    SpinMouseCursor();
  
    t = InputStr; 
 	  l = (int) strlen(InputStr);
    
   	while (l > 0)   
   	{
     	i = 128; 
     	strncpy(p,t,1);      
     	while(i<256)  
     	{
       	if (strchr(p,i))
       	{
         	*t = (char) TabWintoMacOS[i];
         	i  = 999;
       	}
       	else
         	i++;
     	}   
     	t++;      
     	l--;      
    }
    fprintf(fout,"%s\x0D",InputStr);    
  }
 	fclose(fin); 
 	fclose(fout); 
  
  SetDefaultMouseCursor();
    
  return(0);
}  

// ********************
// ********************    
// ********************

void InitTable(int t, int A[256])
{
  if (t < 2)
  {
    A[128] = 196;  //    
    A[129] = 197;  //    
    A[130] = 199;  //    
    A[131] = 201;  //    
    A[132] = 209;  //    
    A[133] = 214;  //    
    A[134] = 220;  //    
    A[135] = 225;  //  
    A[136] = 224;  //  
    A[137] = 226;  //  
    A[138] = 228;  //  
    A[139] = 227;  //  
    A[140] = 229;  //    
    A[141] = 231;  //    
    A[142] = 233;  //    
    A[143] = 232;  //    
    A[144] = 234;  //    
    A[145] = 235;  //    
    A[146] = 237;  //    
    A[147] = 236;  //    
    A[148] = 238;  //    
    A[149] = 239;  //    
    A[150] = 241;  //    
    A[151] = 243;  //    
    A[152] = 242;  //    
    A[153] = 244;  //    
    A[154] = 246;  //    
    A[155] = 245;  //    
    A[156] = 250;  //    
    A[157] = 249;  //    
    A[158] = 251;  //    
    A[159] = 252;  //    
    A[160] = 134;  //    
    A[161] = 176;  //    
    A[162] = 162;  //    
    A[163] = 163;  //    
    A[164] = 167;  //    
    A[165] = 149;  //    
    A[166] = 182;  //    
    A[167] = 223;  //    
    A[168] = 174;  //    
    A[169] = 169;  //    
    A[170] = 153;  //    
    A[171] = 146;  //    
    A[172] = 168;  //    
    A[173] =  95;  //    
    A[174] = 198;  //    
    A[175] = 216;  //    
    A[176] =  95;  //    
    A[177] = 177;  //    
    A[178] =  95;  //    
    A[179] =  95;  //    
    A[180] = 165;  //    
    A[181] = 181;  //    
    A[182] =  95;  //    
    A[183] =  95;  //    
    A[184] =  95;  //    
    A[185] =  95;  //    
    A[186] =  95;  //    
    A[187] = 170;  //    
    A[188] = 186;  //    
    A[189] =  95;  //    
    A[190] = 230;  //    
    A[191] = 248;  //    
    A[192] = 191;  //    
    A[193] = 161;  //    
    A[194] = 172;  //    
    A[195] =  95;  //    
    A[196] = 131;  //    
    A[197] =  95;  //    
    A[198] =  95;  //    
    A[199] = 171;  //    
    A[200] = 187;  //    
    A[201] = 133;  //    
    A[202] =  95;  //    
    A[203] = 192;  //    
    A[204] = 195;  //    
    A[205] = 213;  //    
    A[206] = 140;  //    
    A[207] = 156;  //    
    A[208] = 150;  //    
    A[209] = 151;  //    
    A[210] = 147;  //    
    A[211] = 148;  //    
    A[212] = 145;  //    
    A[213] = 146;  //    
    A[214] = 247;  //    
    A[215] =  95;  //    
    A[216] = 255;  //    
    A[217] = 159;  //    
    A[218] =  47;  //    
    A[219] = 164;  //    
    A[220] = 139;  //    
    A[221] = 155;  //    
    A[222] =  95;  //    
    A[223] =  95;  //    
    A[224] = 135;  //    
    A[225] = 183;  //    
    A[226] =  44;  //    
    A[227] =  95;  //    
    A[228] = 137;  //    
    A[229] = 194;  //    
    A[230] = 202;  //    
    A[231] = 193;  //    
    A[232] = 203;  //    
    A[233] = 200;  //    
    A[234] = 205;  //    
    A[235] = 206;  //    
    A[236] = 207;  //    
    A[237] = 204;  //    
    A[238] = 211;  //    
    A[239] = 212;  //    
    A[240] =  95;  //    
    A[241] = 210;  //    
    A[242] = 218;  //    
    A[243] = 219;  //    
    A[244] = 217;  //    
    A[245] =  95;  //    
    A[246] = 136;  //    
    A[247] = 152;  //    
    A[248] = 175;  //    
    A[249] =  95;  //    
    A[250] =  95;  //    
    A[251] =  95;  //    
    A[252] =  95;  //    
    A[253] = 148;  //    
    A[254] =  95;  //    
    A[255] =  95;  //    
  }
  else
  {
//  Windows  MacOC //  Zeichen unter Windows
    A[128] =  69;  //  Eurozeichen  
    A[129] =  95;  //  _  
    A[130] =  44;  //  ,  
    A[131] = 196;  //    
    A[132] = 227;  //    
    A[133] = 201;  //    
    A[134] = 160;  //    
    A[135] = 224;  //    
    A[136] = 246;  //    
    A[137] = 228;  //    
    A[138] =  95;  //  _ 
    A[139] = 220;  //    
    A[140] = 206;  //    
    A[141] =  95;  //  _  
    A[142] =  95;  //  _  
    A[143] =  95;  //  _  
    A[144] =  95;  //  _  
    A[145] = 212;  //    
    A[146] = 213;  //    
    A[147] = 210;  //  "  
    A[148] = 211;  //  "  
    A[149] = 165;  //    
    A[150] = 208;  //    
    A[151] = 209;  //    
    A[152] = 247;  //    
    A[153] = 170;  //    
    A[154] =  95;  //  _  
    A[155] = 221;  //  >  
    A[156] = 207;  //    
    A[157] =  95;  //  _  
    A[158] =  95;  //  _  
    A[159] = 217;  //    
    A[160] =  95;  //  _  
    A[161] = 193;  //    
    A[162] = 162;  //    
    A[163] = 163;  //    
    A[164] = 219;  //    
    A[165] = 180;  //    
    A[166] = 124;  //  |  
    A[167] = 164;  //    
    A[168] = 172;  //    
    A[169] = 169;  //    
    A[170] = 187;  //    
    A[171] = 199;  //    
    A[172] = 194;  //    
    A[173] = 208;  //    
    A[174] = 168;  //    
    A[175] = 248;  //    
    A[176] = 161;  //    
    A[177] = 177;  //    
    A[178] =  95;  //  _  
    A[179] =  95;  //  _  
    A[180] = 213;  //    
    A[181] = 181;  //    
    A[182] = 166;  //    
    A[183] = 225;  //    
    A[184] = 252;  //    
    A[185] =  95;  //  _  
    A[186] = 161;  //    
    A[187] = 200;  //    
    A[188] =  95;  //  _  
    A[189] =  95;  //  _  
    A[190] =  95;  //  _  
    A[191] = 192;  //    
    A[192] = 203;  //    
    A[193] = 231;  //    
    A[194] = 229;  //    
    A[195] = 204;  //    
    A[196] = 128;  //    
    A[197] = 129;  //    
    A[198] = 174;  //    
    A[199] = 130;  //    
    A[200] = 233;  //    
    A[201] = 131;  //    
    A[202] = 230;  //    
    A[203] = 232;  //    
    A[204] = 237;  //    
    A[205] = 234;  //    
    A[206] = 235;  //    
    A[207] = 236;  //    
    A[208] =  95;  //  _  
    A[209] = 132;  //    
    A[210] = 241;  //    
    A[211] = 238;  //    
    A[212] = 239;  //    
    A[213] = 205;  //    
    A[214] = 133;  //    
    A[215] =  95;  //  _  
    A[216] = 175;  //    
    A[217] = 244;  //    
    A[218] = 242;  //    
    A[219] = 243;  //    
    A[220] = 134;  //    
    A[221] =  95;  //  _  
    A[222] =  95;  //  _  
    A[223] = 167;  //    
    A[224] = 136;  //    
    A[225] = 135;  //    
    A[226] = 137;  //    
    A[227] = 139;  //    
    A[228] = 138;  //    
    A[229] = 140;  //    
    A[230] = 190;  //    
    A[231] = 141;  //    
    A[232] = 143;  //    
    A[233] = 142;  //    
    A[234] = 144;  //    
    A[235] = 145;  //    
    A[236] = 147;  //    
    A[237] = 146;  //    
    A[238] = 148;  //    
    A[239] = 149;  //    
    A[240] =  95;  //  _  
    A[241] = 150;  //    
    A[242] = 152;  //    
    A[243] = 151;  //    
    A[244] = 153;  //    
    A[245] = 155;  //    
    A[246] = 154;  //    
    A[247] = 214;  //    
    A[248] = 191;  //    
    A[249] = 157;  //    
    A[250] = 156;  //    
    A[251] = 158;  //    
    A[252] = 159;  //    
    A[253] =  95;  //  _  
    A[254] =  95;  //  _  
    A[255] = 216;  //    
  }  
}  
