/*******************************************************************
*                                                                  *
*    SplitDataFile.c -- Zerteilen eines Datensatzes                *
*                                                                  *
*    Dr. Rainer Sieger, Universitaet Bremen, 28.12.2000            *
*    Macintosh                                                     *
*    Windows                                                       *
*                                                                  *
*******************************************************************/

#include <string.h>
#include <stdio.h>

#include <Windows.h>
#include "Win_GUI.h"
#include "Win_SplitDataFile.h"
#include "Win_FileSystem.h"

#include "struct.h"
#include "globals.h"

#include "SetMouseCursor.h"
#include "Initialize.h"
#include "CalcNumOfParameters.h"
#include "ExtractHeader.h"
#include "ExtractData.h"
#include "TestMetadata.h"

int SplitFileIncrement = 10;

int SplitDataFile(char *FilenameIn, char *FilenameOut)
{
  FILE    *fin;
  FILE    *fout;

  unsigned long   i				= 0;
  unsigned long   k				= 0;
  unsigned long   h				= 0;
  unsigned long		maxData	= 0;

	long		length					= 0;

	int			j								= 1;

  int     m								= 0;
	int     l								= 1;
  int     s								= l;
	int     e								= 0;

  int     HeaderMode			= 0;
	int			Test						= 1;
	int			err							= 0;

  Str15       Extension		= "";
  StrFullName Filename		= "";
     	
// *******************************************************************
  
	memset((char *) HeaderStr1, (int) '\0', MAXNUMOFCHAR+1);
	memset((char *) HeaderStr2, (int) '\0', MAXNUMOFCHAR+1);

  if ((fin = openFile((char *) FilenameIn, "rb")) == NULL) 
		return(-1);

	while (Test)
	{
		if ((length = readFile(fin,HeaderStr2,MAXNUMOFCHAR)) < 0)
		{
			closeFile(fin);
			return(-1);
		}
		else
		{
			if (TestMetadata(HeaderStr2))
				strcpy((char *) HeaderStr1, (char *) HeaderStr2);
			else
				Test = 0;
		}
	}

  if ((gNumOfParameters = CalcNumOfParameters(HeaderStr2)-1) <= 0)
  {
     closeFile(fin);
     SetDefaultMouseCursor();
     return(-2);
  } 
	else
  {
    InitD();

		if (strlen(HeaderStr1) > 0)
			err = ExtractHeader(gNumOfParameters,HeaderStr1);
    err = ExtractHeader(gNumOfParameters,HeaderStr2);

   	maxData = (unsigned long) gMaxMData;
   	maxData = maxData/((unsigned long) gNumOfParameters + 1);
		for (j=0;j<=gNumOfParameters;j++)  
		{
	 		C[j].Offset      = j*maxData;
	 		Q[C[j].Offset].I = 0;
		}    		

		maxData -= 2;
    gNumOfComments = 0;		        
    for (i=0;i<=gMaxCData;i++)  
    {
     	T[i].Parameter = 0;		        	
      T[i].Depth     = (float) -999.99;
      memset((char *) T[i].Text, (int) '\0', 81);		          
    }  
      
		i = 0;
    while((length > 0) && (++i <= (unsigned long) maxData))
    {
      SpinMouseCursor();
 			length = readFile(fin,InputStr,MAXNUMOFCHAR);
      m      = ExtractData(gNumOfParameters,0,i);
      if (m == -1)
        i--;
      else
				C[0].counts++;
    }
 		closeFile(fin);
	}  
      
  for (l=1;l<=gNumOfParameters;l+=SplitFileIncrement)
  {
  	s = l;    // 1
  	e = s + SplitFileIncrement - 1; // 1 + 49 = 50
  	if (e > gNumOfParameters)
  		e = gNumOfParameters;
  	  
		strcpy((char *) Filename, (char *) FilenameOut);            
  	sprintf((char *) Extension,".%d-%d",s,e);
  	strcat((char *) Filename, (char *) Extension);
   	strcat((char *) Filename, ".PP");
	  
    if ((fout = openNewFile((char *) Filename)) == NULL) 
			return(-5);  

    switch (Mode)
    {
			case HorizontalMode:
			case HorizontalMode-10:	
				sprintf(TempStr,"%s@%s#1",C[0].Header,Copyrighttext);
				writeFile(fout,TempStr);
				break;
    	case VerticalMode:
			case VerticalMode-10:
				sprintf(TempStr,"%s@%s#2",C[0].Header,Copyrighttext);
				writeFile(fout,TempStr);
				break;
			case TernaryMode:
			case TernaryMode-10:	
				sprintf(TempStr,"%s@%s#3",C[0].Header,Copyrighttext);
				writeFile(fout,TempStr);
				break;
			case PhaseMode:
			case PhaseMode-10:	
				sprintf(TempStr,"%s@%s#4",C[0].Header,Copyrighttext);
				writeFile(fout,TempStr);
				break;
		}
		
		for (j=s;j<=e;j++)
		{
	  	sprintf(TempStr,"\t%s",C[j].Header);
			writeFile(fout,TempStr);
		}
	  writeFile(fout,"\n");

		for (i=1;i<=C[0].counts;i++)
		{
	  	SpinMouseCursor();
			sprintf(TempStr,"%G",Q[i].V); 
			writeFile(fout,TempStr);
			for (j=s;j<=e;j++)
			{
		 	  k = C[j].Offset;
		 	  h = 0;
		 	  while (++h <= C[j].counts)
    		  if ((Q[k+h].I == (long) i) || (Q[k+h].I == -1 * (long) i))
    		  {
            if (Q[k+h].I == (long) i)
            {
	            sprintf(TempStr,"\t%G",Q[k+h].V);
							writeFile(fout,TempStr);
	            h = 2*C[j].counts;
            }
            else
            {
	            sprintf(TempStr,"\t-999.999");
							writeFile(fout,TempStr);
	            h = 2*C[j].counts;
            }
	        }  
	      if (h == C[j].counts+1)
	        writeFile(fout,"\t");
	    }    
 		  writeFile(fout,"\n");
  	}	  
 		closeFile(fout);  
	}	
  return(0);
}	

